#include "attack.ih"

Behavior::ConfidenceInterval Attack::getCapability(rf<State> s, rf<Goal> g)
{
  WorldModel &wm = SWorldModel::getInstance();
  
  double const max_distance_to_attack = 50.0;
  
  switch (wm.getPlayMode())
    {
    case Types::KICKOFF_THEM:
    case Types::GOAL_KICK_THEM:
    case Types::CORNER_KICK_THEM:
    case Types::FREEKICK_THEM:
    case Types::KICKIN_THEM:
      return capable(false);
      
    default:
      // If another player is on the ball, wait longer
      if (!d_buffered_if(wm.otherCloserToBall()))
        return capable(true);
      else
        return capable(false);
  }
}
