#include "ballinrange.ih"

Behavior::ConfidenceInterval BallInRange::getCapability(rf<State> s, rf<Goal> g)
{
  WorldModel& wm = SWorldModel::getInstance();
  Vector3D pos;

    if (g->findDeep("PosX"))
        pos = g->getVector("Pos");
    else
    {
      Vector3D ballPosCar = wm.getObject(Types::BALL).position.getMu();
      pos = ballPosCar;
    }

  double ballX = pos.getX();
  double ballY = pos.getY();

  double distToPos = sqrt(ballX * ballX + ballY * ballY);
  
  if (d_buffered_if( distToPos > d_max_distance))
    return capable(false);

 return capable(true);
}

