#include "beamto.ih"

BeamTo::BeamTo(string const &id, string const &playerClass)
  : Behavior("BeamTo", id, playerClass)
{
  d_tree = new AST::Node(sequenceType);
  d_tree->addChild(new AST::Node(andType));
  d_tree->getChild(0)->addChild(new AST::Node(orType));
  d_tree->getChild(0)->addChild(new AST::Node(orType));

/*
  //Load defaults  
  d_posWeGetKickOff[0] = getParam("/where[@wegetkickoff=1]/@x", 0.0);
  d_posWeGetKickOff[1] = getParam("/where[@wegetkickoff=1]/@y", 10.0);
  d_posWeGetKickOff[2] = getParam("/where[@wegetkickoff=1]/@z", 0.0);
 
  _debugLevel1("Default wegetkickoff: " << d_posWeGetKickOff);
  
  d_posTheyGetKickOff[0] = getParam("/where[@wegetkickoff=0]/@x", 0.0);
  d_posTheyGetKickOff[1] = getParam("/where[@wegetkickoff=0]/@y", 10.0);
  d_posTheyGetKickOff[2] = getParam("/where[@wegetkickoff=0]/@z", 0.0);
  
  _debugLevel1("Default theygetkickoff: " << d_posTheyGetKickOff);

  d_coverOpponent = getParam("/where[@wegetkickoff=0]/@cover", 0) == 1;

  _debugLevel1("Default cover: " << (d_coverOpponent ? "yes" : "no"));
*/

  AgentModel& am = SAgentModel::getInstance();

  //Overwrite with specialized if possible
  std::ostringstream ids;
  ids << am.getUnum();
  
  _debugLevel1("unum: " << ids.str());
  
  d_posWeGetKickOff[0] = getParam("/where[@wegetkickoff=1 and @unum="+ids.str()+"]/@x", d_posWeGetKickOff[0]);
  d_posWeGetKickOff[1] = getParam("/where[@wegetkickoff=1 and @unum="+ids.str()+"]/@y", d_posWeGetKickOff[1]);
  d_posWeGetKickOff[2] = getParam("/where[@wegetkickoff=1 and @unum="+ids.str()+"]/@z", d_posWeGetKickOff[2]);
 
  _debugLevel1("My wegetkickoff: " << d_posWeGetKickOff);
  
  d_posTheyGetKickOff[0] = getParam("/where[@wegetkickoff=0 and @unum="+ids.str()+"]/@x", d_posTheyGetKickOff[0]);
  d_posTheyGetKickOff[1] = getParam("/where[@wegetkickoff=0 and @unum="+ids.str()+"]/@y", d_posTheyGetKickOff[1]);
  d_posTheyGetKickOff[2] = getParam("/where[@wegetkickoff=0 and @unum="+ids.str()+"]/@z", d_posTheyGetKickOff[2]);
  
  _debugLevel1("My theygetkickoff: " << d_posTheyGetKickOff);

  d_coverOpponent = getParam("/where[@wegetkickoff=0 and @unum="+ids.str()+"]/@cover", 0) == 1;
  
  _debugLevel1("My cover: " << (d_coverOpponent ? "yes" : "no"));
}
