#include "catchfallfront.ih"

Behavior::ConfidenceInterval CatchFallFront::getCapability(rf<State> s, rf<Goal> g)
{
    AgentModel::FallDirection direction = SAgentModel::getInstance().getDirectionOfFall();

    //switch(s->getMean("DirectionOfFall"))
    switch(direction)
     { 
         case AgentModel::NOT_FALLING:  break; 
        case AgentModel::FALL_TO_FRONT:     _debugLevel1("Falling to the front."); break; 
        case AgentModel::FALL_TO_BACK:     _debugLevel1("Falling to the back."); break;
        case AgentModel::FALL_TO_LEFT:     _debugLevel1("Falling to the left."); break;
        case AgentModel::FALL_TO_RIGHT:     _debugLevel1("Falling to the right."); break;
        
        default: _debugLevel1("Did not recognize direction of Fall!");
    }

    return (direction == AgentModel::FALL_TO_FRONT) 
            ? ConfidenceInterval(0.95, 0.2) 
            : ConfidenceInterval(-1.0, 0.0);
} 
