#ifndef _BATS_COUPLEDWALK_HH_
#define _BATS_COUPLEDWALK_HH_

#include "behavior.hh"
#include "coupledsinefunction.hh"
#include <map>
#include <vector>

namespace bats
{
  class CoupledWalk : public Behavior
  {
    double d_robotPhase;
    Vector3D d_lastCOP;
    
    std::map<Types::Joint, std::vector<rf<CoupledSineFunction> > > d_sines;
    
    virtual void preGenerateGoal(unsigned step);

    virtual rf<Goal> generateGoal(unsigned step, unsigned slot);
    virtual rf<State> getCurrentState();
    virtual ConfidenceInterval getCapability(rf<State> s, rf<Goal> g);
  
  public:
    CoupledWalk(std::string const &id, std::string const &playerClass);
  };
};

#endif
