#include "coupledwalk.ih"

rf<Behavior::Goal> CoupledWalk::generateGoal(unsigned step, unsigned slot)
{
  rf<Goal> goal = new Goal();
  rf<OrNode> dis = goal->addDisjunct();
  rf<AndNode> con = dis->addConjunct();
  
  double angle = 0;
  map<Types::Joint, vector<rf<CoupledSineFunction> > >::iterator sines = d_sines.find((Types::Joint)slot);
  
  if (sines != d_sines.end())
    for (vector<rf<CoupledSineFunction> >::iterator iter = sines->second.begin(); iter != sines->second.end(); ++iter)
    {
      double a = (**iter)(d_robotPhase);
      _debugLevel1("a: " << a);
      angle += a;
    }
  
  _debugLevel1("Angle " << slot << ": " << angle);
  
  con->addVar("Angle", angle, angle);
  
  return goal;
}
