#include "coupledwalk.ih"

void CoupledWalk::preGenerateGoal(unsigned step)
{
  AgentModel& am = SAgentModel::getInstance();
  
  Vector3D leftForceContact = am.getFootForceCenter(Types::LEFT);
  Vector3D rightForceContact = am.getFootForceCenter(Types::RIGHT);
  _debugLevel1(leftForceContact << " " << rightForceContact);
  
  Vector3D COP = leftForceContact * am.getFootForce(Types::LEFT).length() + rightForceContact * am.getFootForce(Types::RIGHT).length();
  if (COP.length() > 0)
    COP /= am.getFootForce(Types::LEFT).length() + am.getFootForce(Types::RIGHT).length();
  
  Vector3D COPderiv = (COP - d_lastCOP) / 0.02;
  
  d_robotPhase = -atan(COPderiv[0] / (COP[0] != 0 ? COP[0] : 0.00000001));
  
  _debugLevel1("Robot phase: " << COPderiv[0] << " " << COP[0] << " " << d_robotPhase);
  
  d_lastCOP = COP;
  
}

