#include "cubicspline.ih"

CubicSpline::CubicSpline(string const &id, string const &playerClass)
:
	Behavior("CubicSpline", id, playerClass)
{
	// The cubic spline is parameterized by points (x,y) which are represented
	// in the param section of the xml as <point t="" y=""/>, the period must
	// be specified with <period>n</period>. The last point of the sequence
	// is automatically added with the same y value as the first point to
	// get periodicity. If the first point is not specified at t=0, then the
	// t = 0 and t = period y values are linearly interpolated between the 
	// first and last specified value

	XMLNodeSet params = Behavior::getParams("/joint");
	
	if (params && !params.empty())
		for (XMLNodeSet::iterator iter = params.begin(); iter != params.end(); ++iter)
			parseJoint(*iter);

	d_tree = new AST::Node(sequenceType);
	d_tree->addChild(new AST::Node(andType));
	
	// Add plenty
	for (size_t i = 0; i < Types::NJOINTS; ++i)
		d_tree->getChild(0)->addChild(new AST::Node(orType));
}

