#include "cubicspline.ih"

rf<Behavior::Goal> CubicSpline::generateGoal(unsigned step, unsigned slot)
{
	// The goal that needs to be satisfied for this behaviour, is a specific
	// angle, that's calculated in calcAngle. A MoveJointTo subbehaviour will
	// satisfy this goal
	rf<Goal> goal = new Goal();
	rf<OrNode> dis = goal->addDisjunct();
	rf<AndNode> con = dis->addConjunct();

	try
	{
		double angle = calcAngle(slot);

		con->addVar("Angle", angle, angle);
	}
	catch (NoGoalException)
	{
	}
  
	return goal;
}

