#include "cubicspline.ih"
#include <cmath>

void
CubicSpline::phaseShift(vector<pair<double, double> > &points, double phase) const
{
	if (phase == 0 || phase == 1)
		return;

	// phase is a number between 0 and 1 which is used to translate all the points by
	for (vector<pair<double, double> >::iterator iter = points.begin(); iter != points.end(); ++iter)
	{
		double intpart;
		double fractional = modf(iter->first + phase, &intpart);
		
		iter->first = fractional < 0 ? 1.0 - fractional : fractional;
	}
}

