#include "defend.ih"

rf<Behavior::Goal> Defend::generateGoal(unsigned step, unsigned slot)
{
  rf<Goal> goal = new Goal();
  rf<OrNode> dis = goal->addDisjunct();
  rf<AndNode> con = dis->addConjunct();
  
  WorldModel& wm = SWorldModel::getInstance();
  
  double min_ball_goal_distance = 3.0;

  Vector3D ballPos = wm.getObject(Types::BALL).position.getMu();
  Vector3D goalCenter = (wm.getObject(Types::GOAL1US).position.getMu() + wm.getObject(Types::GOAL2US).position.getMu()) / 2;
  Vector3D otherGoalCenter = (wm.getObject(Types::GOAL1THEM).position.getMu() + wm.getObject(Types::GOAL2THEM).position.getMu()) / 2;

  ballPos[2] = 0;
  goalCenter[2] = 0;
  otherGoalCenter[2] = 0;
  
  Vector3D goalBallDir = (ballPos - goalCenter).normalize();
  Vector3D perpend = Math::calcPerpend(goalBallDir).normalize();
 
  Vector3D fieldMiddle = otherGoalCenter - goalCenter;
  
  double dist = d_defend_distance * wm.otherCloserToBall(true, true);

  if (wm.getPlayMode() == Types::CORNER_KICK_THEM ||
      wm.getPlayMode() == Types::KICKIN_THEM)
       dist += d_defend_distance;  //afstand houden voor deze gevallen

  Vector3D pos;
  if ((ballPos - goalCenter).length() < min_ball_goal_distance) // ga uit de weg van keeper
  {
      Vector3D optie1 = wm.getObject(Types::GOAL1US).position.getMu() + (wm.getObject(Types::GOAL1THEM).position.getMu() - wm.getObject(Types::GOAL1US).position.getMu()).normalize() * 2.0;
      Vector3D optie2 = wm.getObject(Types::GOAL2US).position.getMu() + (wm.getObject(Types::GOAL2THEM).position.getMu() - wm.getObject(Types::GOAL2US).position.getMu()).normalize() * 2.0;
      
      if (optie1.length() > optie2.length())
        pos = optie2;
      else
        pos = optie1;
      con->addVar("Pos", pos);
      con->addVar("Dir", ballPos.normalize());
  }
  else
  {
      pos = ballPos - goalBallDir * dist;
      
      Vector3D pos1 = pos + perpend * 0.3;
      Vector3D pos2 = pos - perpend * 0.3;
      
      double distFromMiddle1 = Math::distanceLinePoint(goalCenter, fieldMiddle, pos1);
      double distFromMiddle2 = Math::distanceLinePoint(goalCenter, fieldMiddle, pos2);
      
      if (distFromMiddle1 < distFromMiddle2)
        con->addVar("Pos", pos1);
      else
        con->addVar("Pos", pos2);

      con->addVar("Dir", goalBallDir);
    // con->addVar("Var", 0, 1);
  } 
  return goal;
}
