#include "dribble.ih"

Dribble::Dribble(string const &id, string const &playerClass)
  : Behavior("Dribble", id, playerClass)
{
  d_tree = new AST::Node(sequenceType);
  d_tree->addChild(new AST::Node(andType));
  d_tree->getChild(0)->addChild(new AST::Node(orType));
  d_tree->addChild(new AST::Node(andType));
  d_tree->getChild(1)->addChild(new AST::Node(orType));
  d_tree->addChild(new AST::Node(andType));
  d_tree->getChild(2)->addChild(new AST::Node(orType));
  d_tree->getChild(2)->addChild(new AST::Node(orType));
  
  d_brakeDistance = Behavior::getParam("/brakeDistance", 1.2);
  d_targetSpeed = Behavior::getParam("/targetSpeed", 0.6);
  d_tweakPos = Behavior::getParam("/tweakPos", 0.0);
  d_curveFactor = Behavior::getParam("curve/@factor", 0.50);
  d_curveConst = Behavior::getParam("curve/@const", 0.15);
  d_maxCapableAngle = Behavior::getParam("maxCapableAngle", 90);
  d_avoid_players_threshold = Behavior::getParam("/playerThreshold", 1.0);
//  d_curveFactor = Behavior::getParam("maxAngle", 90.0);
}
