#include "fallcommit.ih"

void FallCommit::update()
{
  Behavior::update();

  WorldModel& wm = SWorldModel::getInstance();

  Vector3D ballPos = wm.getObject(Types::BALL).position.getMu();
  ballPos[2] = 0;
  if (ballPos.length() > d_maxBallDist)
  {
    _debugLevel1("Ball too far: " << ballPos.length());
    d_committed = false;
    return;
  }

  if (wm.getPlayMode() == Types::KICKOFF_US)
  {
    d_committed = false;
    return;
  }

  _debugLevel1("Max steptime: " << d_maxStepTime << " stepStart: " << d_curStepStart << " curtime: " << wm.getTime() << " diff: " << wm.getTime() - d_curStepStart);
  if (wm.getTime() - d_curStepStart < d_maxStepTime)
  {
    d_committed = true;
    return;
  }
  //d_committed = d_committed || (ballPos.length() < d_maxBallDist);
}

