#include "fastkickball.ih"

FastKickBall::FastKickBall(string const &id, string const &playerClass)
  : Behavior("FastKickBall", id, playerClass)
{
  d_side = getParam("/side", 0) == 0 ? Types::LEFT : Types::RIGHT;
  
  XMLNodeSet kickParamNodes = getParams("/kick");
  XMLNode node = kickParamNodes.front();
  _debugLevel1(node.getContent());
  
  istringstream in(node.getContent());
  string dummy;  
  in >> dummy >> d_params.xRange.first >> d_params.xRange.second
      >> dummy >> d_params.yRange.first >> d_params.yRange.second
      >> dummy;
  for (unsigned i = 0; i < 11; ++i)
    in >> d_params.amps[i];
  
  d_tree = new AST::Node(sequenceType);
  d_tree->addChild(new AST::Node(andType));
  d_tree->getChild(0)->addChild(new AST::Node(orType));
}
