#ifndef _BATS_FASTKICKBALL_HH_
#define _BATS_FASTKICKBALL_HH_

#include "behavior.hh"

namespace bats
{
  class FastKickBall : public Behavior
  {

    struct KickParams
    {
      std::pair<double, double> xRange;
      std::pair<double, double> yRange;
      double amps[11];
    };

    Types::Side d_side;
    KickParams d_params;
    
    virtual rf<Goal> generateGoal(unsigned step, unsigned slot);
    virtual rf<State> getCurrentState();
    virtual ConfidenceInterval getCapability(rf<State> s, rf<Goal> g);
  
  public:
    FastKickBall(std::string const &id, std::string const &playerClass);
    
    virtual void update();
  };
};

#endif
