#include "fastkickball.ih"

Behavior::ConfidenceInterval FastKickBall::getCapability(rf<State> s, rf<Goal> g)
{
  // Capable when this foot isnt on the ground and the other one is and the ball is in front of your foot
  Types::Side otherSide = d_side == Types::LEFT ? Types::RIGHT : Types::LEFT;
  AgentModel& am = SAgentModel::getInstance();
  WorldModel& wm = SWorldModel::getInstance();
  
  Vector3D ballPos = wm.getObject(Types::BALL).position.getMu();
  rf<AgentModel::Limb> foot = am.getBodyPart(d_side == Types::LEFT ? Types::LFOOT : Types::RFOOT);
  Vector3D toePos = foot->transform.trans() + foot->transform.front() * foot->size[1] / 2.0;
  
  Vector3D relPos = ballPos - toePos;
  
  _debugLevel1(ident() << " Force: " << am.getFootForce(d_side).length() << ", relPos: " << relPos);
  _debugLevel1("z: " << (toePos[2] - wm.getDistToField() - foot->size[2] / 2.0));
  
  double footZ = toePos[2] - wm.getDistToField() - foot->size[2] / 2.0;
  
  if (am.getFootForce(d_side).length() == 0 &&
      relPos[0] >= d_params.xRange.first && relPos[0] <= d_params.xRange.second &&
      relPos[1] >= d_params.yRange.first && relPos[1] <= d_params.yRange.second &&
      footZ > 0.015)
    return capable(true);
  else
    return capable(false);
}
