#include "goodpositionangle.ih"

GoodPositionAngle::GoodPositionAngle(string const &id, string const &playerClass)
  :
    Behavior("GoodPositionAngle", id, playerClass),
    d_defaultPos(Types::BALL),
    d_avoidBehindBall(false),
    d_stableCheck(ON_FEET)
{
  //Load the default target if specified in conf
 
  std::string target = getParam("/defaultPos", string());
  if(target.size())
    d_defaultPos = Types::objectEnumFor(target, d_defaultPos);
  
  d_tree = new AST::Node(sequenceType);
  d_tree->addChild(new AST::Node(andType));
  d_tree->getChild(0)->addChild(new AST::Node(orType));
  d_tree->getChild(0)->addChild(new AST::Node(orType));
  d_tree->getChild(0)->addChild(new AST::Node(orType));

  XMLNodeSet params = getParams("/stablecheck");
  if(params && !params.empty())
  {
    XMLNode scriptNode = params.front();
    d_stableCheck = scriptNode.getContent() == "onfeet" ? ON_FEET : NOT_FALLING;
  }

 d_min_distance = getParam("/distance/@min", 0.6);
 d_min_capable_distance = getParam("/distance/@min_capable", 0.0);
 d_max_distance = getParam("/distance/@max", 4.0);
 d_brake_distance = getParam("/distance/@brake", 0.5);
 d_min_angle = getParam("/distance/@minangle", 5.0) / 180.0 * M_PI;
 d_avoidBehindBall = getParam("/avoidBehindBall", false);
}
