
#include "goodpositionangle.ih"

void GoodPositionAngle::avoidBallBehind(Vector3D *apos)
{
  
  WorldModel& wm = SWorldModel::getInstance();
  //If pos and the avoid are
  Vector3D pos = *apos;
  pos.setZ(0);
  Vector3D avoid = wm.getObject(Types::BALL).position.getMu();
  avoid.setZ(0);
  if(avoid.length() >= pos.length())//Avoid is to far away
  {
    if (avoid.angle(Vector3D(0., 1., 0.)) > (M_PI * (1.5 / 8.0)))
        *apos = *apos - avoid.normalize() * 0.1; //iets afstand houden  
    return;
  }
  //Only avoid behind us
  float avoidAngle = Math::cartesianToPolar(avoid, true).getY();
  float extra = M_PI/30.0;//Extra angel at the sides, to allow for a full pass of the avoided object
  if(avoidAngle > extra && avoidAngle < M_PI - extra)
    return;
  _debugLevel3("Avoid behind us and in range");
  Vector3D nextToAvoid = pos.normalize() * avoid.length(); //Vector where we would pass the avoid
  //If the position we want to go to and the position we want to avoid are
  //  to close, we can't do it
  //TODO use avoid angle to actually calculate theis
  //Ball is 0.042 and robot is about 0.3, 0.3 is to close
  Vector3D diff = nextToAvoid - avoid;
  if(diff.length() > 0.3)
  {
    _debugLevel3("Already passing it at " << (avoid - nextToAvoid).length() << " distance");
    return;
  }
  
  /*
  //If avoidance and position angle are approx equal, we have a problem
  float avoidAngle = Math::cartesianToPolar(avoid, true).getY();
  float posAngle = Math::cartesianToPolar(*pos, true).getY();
  
  if(fabsf(avoidAngle - posAngle) > M_PI/10)
    return;
  _debugLevel2("Avoiding something because ");
  */
  //So, now we have a collision. The best thing to do is make the distance
  //larger
  //Get a vector next to avoid with a distance larger then it currently is

  //Currently diff is to small, make it a minimal something
  _debugLevel2("Avoid difference: " << diff);
//  _debugLevel2("")
  //Rewrite the pos to a new value
  *apos = avoid + diff.normalize()*0.5;
  
}
