#include "goodpositionangle.ih"

void GoodPositionAngle::update()
{
  Behavior::update();
  
  if (d_committed)
  {
  	_debugLevel1("GoodposAngle is already committed.");
    return;
  }
    
  if (!d_goal)
    d_committed = false;
  else
  {
    rf<StateVarNode> posNode, angleNode, dirNode;
    
    posNode = rf_cast<StateVarNode>(d_goal->findDeep("PosX"));
    angleNode = rf_cast<StateVarNode>(d_goal->findDeep("Angle"));
    dirNode = rf_cast<StateVarNode>(d_goal->findDeep("DirX"));
    _debugLevel4((posNode ? "yes " : "no "));
    _debugLevel4((angleNode ? "yes " : "no "));
    if(posNode && (angleNode || dirNode))
    {
      Vector3D pos = d_goal->getVector("Pos");

			//used by walkToAngle.
    	/*if (d_goal->findDeep("FinalPosX"))
    		pos = d_goal->getVector("FinalPos");  */
      
      
      pos.setZ(0);

      double angle = 0;
      if (angleNode)
        angle = angleNode->getVar().second.mean();
      else
      {
        Vector3D d = d_goal->getVector("Dir");
        _debugLevel4("d: " << d);
        angle = atan2(d[0], d[1]);
      }
      
      //WorldModel& wm = SWorldModel::getInstance();
      
      
      _debugLevel4("Pos: " << pos << ", angle: " << angle);
      _debugLevel4("Min dis: " << d_min_distance << ", min angle: " << d_min_angle);
      
      d_committed = d_committed ||
                    (pos.length() > d_min_distance && fabs(angle) > d_min_angle && pos.length() < d_max_distance);
                    
      _debugLevel4("d_committed: " << d_committed);
      
      _debugLevel4("Committed: " << (d_committed ? "yes" : "no"));
    }
    else
      d_committed = false;
  }
}

