#include "guardgoal.ih"

namespace {

bool isBehindOurGoalLine(bats::WorldModel &wm, Vector3D pos)
{
  

  //WorldModel& wm = SWorldModel::getInstance();
  return !Math::atSameSideOf(wm.getObject(Types::GOAL1US).position.getMu(), pos, wm.getObject(Types::GOAL1THEM).position.getMu());


/*
  Vector3D g1Them = wm.getObject(Types::GOAL1THEM).position.getMu();
  g1Them.setZ(0);
  Vector3D g2Them = wm.getObject(Types::GOAL2THEM).position.getMu();
  g2Them.setZ(0);
  Vector3D g1Us = wm.getObject(Types::GOAL1US).position.getMu();
  g1Us.setZ(0);
  pos.setZ(0);
  
  double distOurGoal = Math::distanceLinePoint(g1Them,
                                               g2Them - g1Them,
                                               g1Us);
  double distPos = Math::distanceLinePoint(g1Them,
                                               g2Them - g1Them,
                                               pos);
  _debugLevel2(distOurGoal);
  _debugLevel2("distpos" << distPos);
  return distPos > distOurGoal;
*/  
  //Vector3D goalCenter = (wm.getObject(Types::GOAL1US).position.getMu() + wm.getObject(Types::GOAL2US).position.getMu()) / 2.0;

  //If the ball is behind the goal, then use the center of the field
  //Transform to world coordinates
  Matrix4D trans = Math::getTransform(
                                wm.getObject(Types::FLAG2US).position.getMu(),
                                wm.getObject(Types::FLAG1US).position.getMu(),
                                wm.getObject(Types::FLAG1THEM).position.getMu()
                                );

  Vector3D worldPos = trans * pos;
  //Vector3D worldGoal = trans * goalCenter;//wm.getObject(Types::FLAG1US).position.getMu(); the left corner flag and the ball.
  //Vector3D worldDir = worldBall - worldGoal;

  float worldPosAngle = Math::cartesianToPolar(worldPos, true).getY();
  //float worldDirAngle = Math::cartesianToPolar(worldDir, true).getY();
  _debugLevel2("Worlddirangle isBehindOurGoalLine: " << worldPosAngle);
  return worldPosAngle < -M_PI && worldPosAngle > -0.5*M_PI;

}
}



rf<Behavior::Goal> GuardGoal::generateGoal(unsigned step, unsigned slot)
{
  rf<Goal> goal = new Goal();
  rf<OrNode> dis = goal->addDisjunct();
  rf<AndNode> con = dis->addConjunct();

  WorldModel &wm = SWorldModel::getInstance();
  Vector3D goalCenter = (wm.getObject(Types::GOAL1US).position.getMu() + wm.getObject(Types::GOAL2US).position.getMu()) / 2.0;
  Vector3D ballPos = wm.getObject(Types::BALL).position.getMu();
  Vector3D dir = ballPos - goalCenter;
  Vector3D normDir = dir.normalize();

  //If the ball is behind the goal, then use the center of the field
  //Transform to world coordinates
/*
   Matrix4D trans = Math::getTransform(
                                wm.getObject(Types::FLAG2US).position.getMu(),
                                wm.getObject(Types::FLAG1US).position.getMu(),
                                wm.getObject(Types::FLAG1THEM).position.getMu()
                                );

  Vector3D worldBall = trans * ballPos;
  Vector3D worldGoal = trans * goalCenter;//wm.getObject(Types::FLAG1US).position.getMu(); the left corner flag and the ball.
  Vector3D worldDir = worldBall - worldGoal;

  float worldDirAngle = Math::cartesianToPolar(worldDir, true).getY();
  _debugLevel3("worldDirAngle: " << worldDirAngle);
*/
  //if(worldDirAngle > -M_PI && worldDirAngle < 0)
  _debugLevel2("Ball is behind: " << isBehindOurGoalLine(wm, ballPos));
  if(isBehindOurGoalLine(wm, ballPos))
  {
    ballPos = (wm.getObject(Types::FLAG1L).position.getMu() + wm.getObject(Types::FLAG2R).position.getMu()) / 2.0;
    _debugLevel2("Ball behind of field (Dir)");
  }


  //Get the right point on the circle
  //We reduce the circle radius if the ball is well inside the radius
  float radius = d_radius; //Default
  if((dir.length() - wm.getBallRadius() * 3) < radius)
	  	radius = dir.length() - wm.getBallRadius() * 3;

  //On the cirlce with the radius..
  // find that point which leaves
  float offset = d_offset;//offset: the number of meters next to the actual intersection point of ball-goal and circle
  float alpha = offset/radius;//Rotation from ball-goal aan offset further on the circle

  //Find the point that is closest, so we walk as little as possible
  // Just caclulate the two candidates and take the closest one
  Vector3D intersect = normDir * radius;
  _debugLevel2(intersect);
  Matrix4D rotmat = Matrix4D::rotation(Vector3D(0,0, alpha));
  Vector3D c1 = rotmat * intersect;
  //Is behidn
  rotmat = Matrix4D::rotation(Vector3D(0,0, -alpha));
  Vector3D c2 = rotmat * intersect;
  _debugLevel3("c1 " << c1);
  _debugLevel3("c2 " << c2);
  

  Vector3D pos = goalCenter + c1;
	Vector3D pos2 = goalCenter + c2;
  _debugLevel1("I am behind goalline: " << isBehindOurGoalLine(wm, Vector3D(0,0,0)));
  //_debugLevel1("Ball is behind goalline: " << isBehindOurGoalLine(wm, ballPos));

	//If the first is behind the goal, make it the second
	//If the second pos is behind the goal, make it the first
	if(isBehindOurGoalLine(wm, pos))
	{
	  _debugLevel1("Pos 1 behind goal");
	  pos = pos2;
	}
	else if(isBehindOurGoalLine(wm, pos2))
	{
	  _debugLevel1("Pos 2 behind goal");
	  pos2 = pos;
	}
	
  //Switch if the other point is closer or this point is behind the goal.
  if(pos2.length() < pos.length())// || isBehindOurGoalLine(wm, pos))
  {
    //if(isBehindOurGoalLine(wm, pos))
    _debugLevel3("Pos 2 is closest");
	  pos = pos2;
  }

  con->addVar("Pos", pos);
  con->addVar("Dir", normDir);

  return goal;
}
