#include "guardgoal.ih"

Behavior::ConfidenceInterval GuardGoal::getCapability(rf<State> s, rf<Goal> g)
{
  WorldModel& wm = SWorldModel::getInstance();
  AgentModel& am = SAgentModel::getInstance();

  Vector3D ballPos = wm.getObject(Types::BALL).position.getMu();

  // or do we want to use am.onMyFeet() ?
  if (am.isDown())
  {
    _debugLevel1("Too close to floor");
    return capable(false);
  }

//  cerr << ballPos.length() << endl;

  //We are next to the ball
  if (ballPos.length() <= wm.getBallRadius()*3)
	  return capable(false);

  //Rest of the field, we follow
  return ConfidenceInterval(0.7, 0.2);
}
