#ifndef _BATS_KEEPERFALL_HH_
#define _BATS_KEEPERFALL_HH_

#include "behavior.hh"

namespace bats
{
  class KeeperFall : public Behavior
  {
    bool d_right; ///< Whether we are falling to the right in our subbehavior
    float d_radius; ///< Minimal distance of the ball to start falling
    
    virtual rf<Goal> generateGoal(unsigned step, unsigned slot);
    virtual rf<State> getCurrentState();
    virtual ConfidenceInterval getCapability(rf<State> s, rf<Goal> g);
  
  public:
    KeeperFall(std::string const &id, std::string const &playerClass);
  };
};

#endif
