#ifndef _BATS_KICKBALL_HH_
#define _BATS_KICKBALL_HH_

#include "behavior.hh"
#include "worldmodel.hh"
#include <map>
#include <utility>

namespace bats
{
  class KickBall : public Behavior
  {
    enum SwingState
    {
      AIM,
      SWING_BACK,
      SWING_FRONT
    };
    
    struct KickParams
    {
      std::pair<double, double> xRange;
      std::pair<double, double> yRange;
      double maxAngle;
      Vector3D footPos;
      double amps[11];
    };
    
    double d_maxBallDist;
    double d_maxStepTime;
    
    std::map<Vector3D, KickParams> d_kickParams;
    Types::Side d_side;
    
    Vector3D d_dir;
    
    virtual rf<Goal> generateGoal(unsigned step, unsigned slot);
    virtual rf<State> getCurrentState();
    virtual ConfidenceInterval getCapability(rf<State> s, rf<Goal> g);
  
  public:
    KickBall(std::string const &id, std::string const &playerClass);
    
    virtual void reset() { Behavior::reset(); }
    virtual void update();
  };
};

#endif
