#include "kickin.ih"

rf<Behavior::Goal> KickIn::generateGoal(unsigned step, unsigned slot)
{
 rf<Goal> goal = new Goal();
  rf<OrNode> dis = goal->addDisjunct();
  rf<AndNode> con = dis->addConjunct();

  if (step == 0)
  {
    con->addVar("TargetSpeed", .5, .5); //todo???
  	con->addVar("BrakeDistance", 1.4, 1.4); //todo???
  } else if (step == 1)
  {
    con->addVar("TargetSpeed", .5, .5); //todo???
  	con->addVar("BrakeDistance", 1.4, 1.4); //todo???
  }

  // con->addVar("Var", 0, 1);
  else if (step == 2)
  {
    WorldModel &wm = SWorldModel::getInstance();
    Vector3D goal1Pos = wm.getObject(Types::GOAL1THEM).position.getMu();
    Vector3D goal2Pos = wm.getObject(Types::GOAL2THEM).position.getMu();
    Vector3D ballPos = SWorldModel::getInstance().getObjectPositionLocal(Types::BALL).getMu();
    Vector3D ownPos = wm.getObject(Types::SELF).position.getMu();
    Vector3D teamMemberPos;
    bool teamMemberFound = false;

    for (unsigned int i(Types::PLAYER1); i < ((unsigned int)Types::PLAYER1 + wm.getNumberOfPlayers()); ++i)
    {
      Vector3D tempPos = wm.getObject(static_cast<Types::Object>(i)).position.getMu();

    //You don't have to pass ball to yourself
      teamMemberFound = (tempPos != ownPos);

      if (teamMemberFound)
      {
        teamMemberPos = tempPos;
        break;
      }
    }

    Vector3D inFrontOfTeamMember;
    Vector3D themGoal = (goal1Pos + goal2Pos) /2;
    if (teamMemberFound)
    {
       inFrontOfTeamMember = teamMemberPos + (themGoal - teamMemberPos).normalize()*2;
       _debugLevel1("passing to teammember.");
    }
    else
    {
       inFrontOfTeamMember = themGoal;
       _debugLevel1("did not find teammember.");
    }

    Vector3D goalXYPos = inFrontOfTeamMember;
    goalXYPos.setZ(0);
    Vector3D straight(0,1,0);

    double angle = straight.angle(goalXYPos);
    if (goalXYPos.getY() > 0)
      angle = -angle;

    Vector3D dir = inFrontOfTeamMember - ballPos;

    Vector3D nDir = dir.normalize();

    _debugLevel4(ballPos << " " << dir);
    ballPos = ballPos - nDir * 0.8;//dir / dir.length() * 0.9;
    _debugLevel4(ballPos);

    // This can be negative to go for the other foot!
    Vector3D ballPosRight = nDir.crossProduct(Vector3D(0,0,1));
    //    ballPosLeft.setX(dir.getY());
    //    ballPosLeft.setY(dir.getX());

    _debugLevel4(goal1Pos << " " << goal2Pos << " " << goalPos << " " << angle);

    Vector3D targetPos = ballPos + ballPosRight.normalize() * (ballPos.getX() < 0 ? .5 : -.5);

    _debugLevel4(ballPos << " " << targetPos);
/*    if (!Math::atSameSideOf(ballPos, targetPos, Vector3D(0,0,0)))
    {
      targetPos = ballPos + ballPosLeft.normalize() * 4;
      if (!Math::atSameSideOf(ballPos, Vector3D(0,0,0), targetPos))
        targetPos = ballPos - ballPosLeft.normalize() * 4;
    }
*/

    con->addVar("Pos", targetPos);
    con->addVar("Angle", angle, angle);
  }
  else if (step == 3)
  {
    //this needs to be adjusted to the distance of the teammember
    con->addVar("FootPos", Vector3D(0,-0.45,-0.15));
    con->addVar("HipAngle", 0, 0);
    con->addVar("KickPower", 0.18, 0.18);
  }

  return goal;
}
