#include "kickoff.ih"

rf<Behavior::Goal> KickOff::generateGoal(unsigned step, unsigned slot)
{
  rf<Goal> goal = new Goal();
  rf<OrNode> dis = goal->addDisjunct();
  rf<AndNode> con = dis->addConjunct();

  WorldModel& wm = SWorldModel::getInstance();
  
  _debugLevel1("KickOff::generateGoal");
  
  // Select player that is the least behind you
  double minY = -12;
  Vector3D dir(0, 1, 0);
  for (WorldModel::player_iterator iter = wm.beginPlayers(); iter != wm.endPlayers(); ++iter)
  {
    PlayerInfo info = iter->second;
    _debugLevel1("player pos: " << info.getPosition());
    
    if (info.getPosition()[1] > minY)
    {
      dir = info.getPosition()[0] < 0 ? Vector3D(-1, 0, 0) : Vector3D(1, 0, 0);
      minY = info.getPosition()[1];
    }
  }
  
  con->addVar("Dir", dir);
  
  return goal;
}
