#include "localbehavior.ih"

rf<Behavior::Goal> LocalBehavior::generateGoal(unsigned step, unsigned slot)
{
  rf<Goal> goal = new Goal();
  rf<OrNode> dis = goal->addDisjunct();
  rf<AndNode> con = dis->addConjunct();

  WorldModel &wm = SWorldModel::getInstance();
  Vector3D ballPos = wm.getObject(Types::BALL).position.getMu();
  Vector3D oppGoalPos = (wm.getObject(Types::GOAL1THEM).position.getMu() + wm.getObject(Types::GOAL2THEM).position.getMu()) / 2;
  Vector3D dir = oppGoalPos - ballPos;
  Vector3D orth = (wm.getObject(Types::GOAL2US).position.getMu() - wm.getObject(Types::GOAL1US).position.getMu()).normalize();
  Vector3D pos = ballPos + dir.normalize()*-0.2;

  if (ballPos.dotProduct(dir) < 0)
    pos += orth * 0.5;

  if (step == 0)
  {
    con->addVar("Pos",pos);
    con->addVar("Dir", dir);
  }
  else
  {
    Vector3D kickDir = (wm.getObject(Types::GOAL1THEM).position.getMu() + wm.getObject(Types::GOAL2THEM).position.getMu()) / 2;
    con->addVar("Dir", kickDir);
  }
  return goal;
}
