#include "miniwalkcombined.ih"

Behavior::ConfidenceInterval MiniWalkCombined::getCapability(rf<State> s, rf<Goal> g)
{
  //pos
  Vector3D pos = g->getVector("Pos");

  //direction
  rf<StateVarNode> angleNode = rf_cast<StateVarNode>(g->findDeep("Angle"));

    
  d_direction[0] = pos.getX();
  d_direction[1] = pos.getY();
  d_direction[2] = 0.0;
  if (angleNode)
  {
    StateVar angleVar = angleNode->getVar();
    double angle = angleVar.second.mean();
    d_direction[2] = angle;
  }
  else
    _debugLevel1("miniwalkcombined doesn't understand!");

  updateParameters();
  update();

  return ConfidenceInterval(1.0, 1.0);
}
