#include "miniwalkcombined.ih"

void MiniWalkCombined::updateParameters()
{
  vector<double> parameters(6);
  size_t const X(0);
  size_t const Y(1);
  size_t const T(2);

  parameters[0] = d_direction[Y] > 0 ? 1 : 0;
  parameters[1] = d_direction[Y] > 0 ? 0 : 1;
  parameters[2] = d_direction[X] > 0 ? 1 : 0;
  parameters[3] = d_direction[X] > 0 ? 0 : 1;
  parameters[4] = d_direction[T] > 0 ? 1 : 0;
  parameters[5] = d_direction[T] > 0 ? 0 : 1;

  fill(parameters.begin(), parameters.end(), 0);
  parameters[0] = 1;
  parameters[2] = 1;
  
  d_walk_generator->updateWeights(parameters);
}
