#include "movecomto.ih"

MoveCOMTo::MoveCOMTo(string const &id, string const &playerClass)
  : Behavior("MoveCOMTo", id, playerClass),
    d_factor(5.0)
{
  d_tree = new AST::Node(sequenceType);
  d_tree->addChild(new AST::Node(andType));
  
  for (unsigned i = 0; i < 4; ++i)
    d_tree->getChild(0)->addChild(new AST::Node(orType));
    
  d_side = Types::RIGHT;

  XMLNodeSet params = getParams("/side");
  if(params && !params.empty())
  {
    XMLNode scriptNode = params.front();
    if (scriptNode.getContent() == "0")
      d_side = Types::LEFT;
  }

  params = getParams("/factor");
  if(params && !params.empty())
  {
    XMLNode scriptNode = params.front();
    d_factor = atof(scriptNode.getContent().c_str());
  }

}
