#include "movecomto.ih"

void MoveCOMTo::preGenerateGoal(unsigned step)
{
  memset(d_angles, 0, sizeof(double) * 4);

  AgentModel& am = SAgentModel::getInstance();
  //WorldModel& wm = SWorldModel::getInstance();
  Vector3D com = am.getCOM();
  Vector3D foot = am.getBodyPart(d_side == Types::LEFT ? Types::LFOOT : Types::RFOOT)->transform.trans();
  Vector3D rel = com - foot;
  
  Vector3D target = d_goal->getVector("Target");
  
  Vector3D diff = target - rel;
  
  _debugLevel2(ident() << " COM:\t" << com);
  _debugLevel2(ident() << " foot:\t" << foot);
  _debugLevel2(ident() << " rel:\t" << rel);
  _debugLevel2(ident() << " diff:\t" << diff);
  
  Vector3D angleDiffs = diff * d_factor;
  _debugLevel2(ident() << " adiffs:\t" << angleDiffs);
  
  Types::Joint leg1 = d_side == Types::LEFT ? Types::LLEG1 : Types::RLEG1;
  
  d_angles[0] = -angleDiffs.getY() + am.getJoint(static_cast<Types::Joint>(leg1 + 1))->angle.getMu();
  d_angles[1] = angleDiffs.getX() + am.getJoint(static_cast<Types::Joint>(leg1 + 2))->angle.getMu();
  
  d_angles[2] = -d_angles[0];
  d_angles[3] = -d_angles[1];
  
  _debugLevel2(ident() << " angle: " << am.getJoint(static_cast<Types::Joint>(leg1 + 2))->angle.getMu());
  _debugLevel2(d_angles[1]);
}

