#include "panickick.ih"

Behavior::ConfidenceInterval PanicKick::getCapability(rf<State> s, rf<Goal> g)
{
  // Panic if an opponent is near the ball
  WorldModel& wm = SWorldModel::getInstance();
  Vector3D ballPos = wm.getObject(Types::BALL).position.getMu();
  Vector3D goalPos = (wm.getObject(Types::GOAL1US).position.getMu() + wm.getObject(Types::GOAL1US).position.getMu()) / 2;
  ballPos[2] = 0;
  
  _debugLevel1("ballPos: " << ballPos);
  _debugLevel1("goalPos: " << goalPos);
  // Dont panic if we are looking at our own goal
  if (goalPos[1] > 0)
    return capable(false);
    
  double closest = 25.0;
  for (WorldModel::player_iterator iter = wm.beginOpponents(); iter != wm.endOpponents(); ++iter)
  {
    PlayerInfo info = iter->second;
    Vector3D playerPos = info.getPosition();
    _debugLevel1("Opponent position: " << playerPos);
    playerPos[2] = 0;
    double dist = (ballPos - playerPos).length();
    if (dist < closest)
      closest = dist;
  }
  
  if (closest < d_max_distance)
    return capable(true);
  else
    return capable(false);
}
