#include "pass.ih"

rf<Behavior::Goal> Pass::generateGoal(unsigned step, unsigned slot)
{
  WorldModel& wm = SWorldModel::getInstance();
  //_debugLevel3("Genreating glaksdlk");
  rf<Goal> goal = new Goal();
  rf<OrNode> dis = goal->addDisjunct();
  rf<AndNode> con = dis->addConjunct();
  std::vector<Target> targets;
  getTargetsInto(&targets);
  sort(targets.begin(), targets.end());


  if(step == 0)
  { //Goodangle
      Vector3D ballPos = wm.getObject(Types::BALL).position.getMu();
      Vector3D oppGoalPos = (wm.getObject(Types::GOAL1THEM).position.getMu() + wm.getObject(Types::GOAL2THEM).position.getMu()) / 2;
      //If we can, use a target instead of the GoalPos
      if( not targets.empty())
	    oppGoalPos = targets[0].location.getMu();
      Vector3D dir = oppGoalPos - ballPos;
      Vector3D ballPosRight = dir.crossProduct(Vector3D(0,0,1)).normalize();
      Vector3D pos = ballPos + dir.normalize()*-0.14;
      pos = pos + ballPosRight * 0.055;

      con->addVar("Dir", dir);
      con->addVar("Pos", pos);
  } else if (step == 1)
  {
	  //Pass in safest target direction
	  if( not targets.empty())
	    con->addVar("Dir", targets[0].location.getMu());
  }

  return goal;
}
