#include "pass.ih"

Behavior::ConfidenceInterval Pass::getCapability(rf<State> s, rf<Goal> g)
{
  //return capable(true);
  //Find all targets possible
  std::vector<Target> targets;
  getTargetsInto(&targets);
  sort(targets.begin(), targets.end());

  WorldModel& wm = SWorldModel::getInstance();

  //TODO Game state capabilities???
  // Niet als we richting eigen goal kijken
  float oppGoalAngle = wm.getDirectionOfOpponentGoal().getY();
  float safe = 0.125 * M_PI; //Safe is a maximum change of 1/8 or 180 degrees
  //The opponent goal must be between .5 M_PI - safe and .5 M_PI + safe
  if(oppGoalAngle < .5 * M_PI - safe || oppGoalAngle > .5 * M_PI + safe)
  {
    _debugLevel3("Not looking towards own goal, oppGoalAngle=" << oppGoalAngle);
    return capable(false);
  }

  // Niet als de afstand groter is dan wat Sander kan,
  //    misschien moet dat ook gewoon in de selectie van de targets komen.


  //The confidence is equal to the maximum freeAngle of the possible targets
  //Devided by the maximum possible is M_PI (180)
  if( not targets.empty())
  {
    _debugLevel3("Capable, confidence=" << targets[0].minimalSafeAngle()/M_PI);
//    return ConfidenceInterval(targets[0].minimalSafeAngle()/M_PI, 0.2);
//    cout << "GoalKick pass capable" << endl;
    return capable(true);
  }
  _debugLevel4("Not capable");
  return capable(false);
}
