#ifndef _BATS_Pass_HH_
#define _BATS_Pass_HH_

#include "behavior.hh"
//#include "../Distribution1/NormalDistribution1/normaldistribution1.hh"
#include "../../Distribution3D/NormalDistribution3D/normaldistribution3d.hh"
#include <utility>
#include <vector>

namespace bats
{
  /**
    Find the best passing direction and place that in the goal.
  */
  class Pass : public Behavior
  {
   public:
    struct Target
    {
      NormalDistribution3D location; ///< Location of the player you can pass to
      Vector3D direction; ///< Direction of the player you can pass to
      std::pair<float, float> safeAngle; ///<Minimum and maximum safe angle in radials: first is left (maximum), second is right (minimum)
      float minimalSafeAngle() const;
      int operator<(Target const &b) const
      {
        return minimalSafeAngle() < b.minimalSafeAngle();
      }
    };

  private:    
    virtual rf<Goal> generateGoal(unsigned step, unsigned slot);
    virtual rf<State> getCurrentState();
    virtual ConfidenceInterval getCapability(rf<State> s, rf<Goal> g);
    void getTargetsInto(std::vector<Target> *targetList) const;
    
  public:
    Pass(std::string const &id, std::string const &playerClass);



  };
};

#endif
