#include "periodicjoint.ih"

PeriodicJoint::PeriodicJoint(double period, double delay, double modulationSpan)
:
	d_modulationSpan(modulationSpan),
	d_startTime(-1.0),
	d_initTime(-1.0),
	d_delay(delay),
	d_period(period),
	d_amplitudeStart(0.0),
	d_frequencyStart(0.0),
	d_prevFrequencyTime(-1.0),
	d_prevSimuTime(0.0),

	d_factor(&PeriodicJoint::factor),
	
	d_amplitude(&PeriodicJoint::factorNoop),
	d_sampleTime(&PeriodicJoint::modulateTimeNoop)
{
}

