#include "periodicjoint.ih"

double
PeriodicJoint::factor()
{
	// This function modulates a factor from 0-1 given the current time
	// and the given modulateSpan
	WorldModel &wm = SWorldModel::getInstance();
	double now = wm.getTime();;
	
	if (d_startTime < 0.0)
		d_startTime = now;
	
	double dt = now - d_startTime;
	
	if (dt > d_modulationSpan * d_period)
	{
		d_factor = &PeriodicJoint::factorNoop;
		return 1.0;
	}
	else
	{
		return dt / (d_modulationSpan * d_period);
	}
}

