#include "periodicjoint.ih"
#define _zero(v) v < 0.001 && v > -0.001
double
PeriodicJoint::modulateTimeReal(double factor)
{
	// This is a really cool function. It will return a sample from 0 -> period given
	// the given factor, and the current time cycle

	WorldModel &wm = SWorldModel::getInstance();
	double now = wm.getTime();
	
	if (_zero(d_startTime))
		d_startTime = now;
	
	if (d_prevFrequencyTime < 0)
		d_prevFrequencyTime = now;

	double dt = now - d_startTime;
	
	if (_zero(dt))
		return 0;
		
	if (_zero(factor))
		return 0;

	double part = d_frequencyStart + (1 - d_frequencyStart) * (1 / factor);

	if (_zero(part))
		return 0;
	
	double samplePeriod = part * d_period;
	double fdt = now - d_prevFrequencyTime;
	
	d_prevSimuTime += (fdt / samplePeriod) * d_period;
	d_prevFrequencyTime = now;

	return fmod(d_prevSimuTime, d_period);
}

