#include "playmode.ih"

PlayMode::PlayMode(string const &id, string const &playerClass)
  : Behavior("PlayMode", id, playerClass)
{
  std::string pms[] = {
	"UNKNOWN",
	"BEFORE_KICKOFF",
	"KICKOFF_LEFT",
	"KICKOFF_RIGHT",
	"KICKOFF_US",
	"KICKOFF_THEM",
	"PLAY_ON",
	"FREEKICK_LEFT",
	"FREEKICK_RIGHT",
	"FREEKICK_US",
	"FREEKICK_THEM",
	"GOAL_LEFT",
	"GOAL_RIGHT",
	"GOAL_US",
	"GOAL_THEM",
	"GOAL_KICK_LEFT",
	"GOAL_KICK_RIGHT",
	"GOAL_KICK_US",
	"GOAL_KICK_THEM",
	"CORNER_KICK_LEFT",
	"CORNER_KICK_RIGHT",
	"CORNER_KICK_US",
	"CORNER_KICK_THEM",
	"KICKIN_LEFT",
	"KICKIN_RIGHT",
	"KICKIN_US",
	"KICKIN_THEM"
};
  std::string playmodes = getParam("/playmodes").getContent();
  std::istringstream s(playmodes + " ");
  _debugLevel1("Param: " << playmodes);
  while(true)
  {
    std::string mode;
    s >> mode;
    if(s.eof())
      break;
    _debugLevel3(mode);
    for(size_t i = 0; i < sizeof(pms)/sizeof(std::string*); ++i)
    {
      _debugLevel4(pms[i] << " ?= " << mode);
      if(mode == pms[i])
      {
        d_modes.push_back(static_cast<Types::PlayMode>(i));
        break;
      }
    }
  }
  d_not = getParam("/playmodes/@not", 0) > 0.5;
  _foreach(dm, d_modes)
  {
    _debugLevel1("PlaymodeOn: " << (d_not ? "NOT " : "") << *dm);
  }

  d_tree = new AST::Node(sequenceType);
        for(unsigned i = 0; i < 4; ++i)
        {
	        d_tree->addChild(new AST::Node(andType));
	        d_tree->getChild(i)->addChild(new AST::Node(orType));
	        d_tree->getChild(i)->addChild(new AST::Node(orType));
	        d_tree->getChild(i)->addChild(new AST::Node(orType));
	        d_tree->getChild(i)->addChild(new AST::Node(orType));
	        d_tree->getChild(i)->addChild(new AST::Node(orType));
	        d_tree->getChild(i)->addChild(new AST::Node(orType));
	        d_tree->getChild(i)->addChild(new AST::Node(orType));
        }
 assert(d_modes.size());  
}
