#include "positionarm.ih"

Behavior::ConfidenceInterval PositionArm::getCapability(rf<State> s, rf<Goal> g)
{
  AgentModel& am = SAgentModel::getInstance();
  WorldModel& wm = SWorldModel::getInstance();

  Vector3D ballPos = wm.getObject(Types::BALL).position.getMu();

  Vector3D target = g->getVector("Target");

    if (d_side == Types::RIGHT)
      {
        // Ball must be in front and right of right foot, but not too far
        Vector3D shoulderPos = am.getBodyPart(Types::RHAND1)->transform.trans();
        //cerr << "ballPos RIGHT: " << ballPos << endl;
        //cerr << "shoulderPos RIGHT: " << shoulderPos << endl;
        _debugLevel1("positionRightArm: " << ballPos << ", " << shoulderPos);


        if (ballPos.getX() > 0.0 && target.getZ() > 0.5 && target.getZ() < 5.0) //&& ballPos.getY() < 10.0
          return capable(true);
        else
          return capable(false);

      }
      else
      {
        Vector3D shoulderPos = am.getBodyPart(Types::LHAND1)->transform.trans();
        //cerr << "ballPos LEFT: " << ballPos << endl;
        //cerr << "shoulderPos LEFT: " << shoulderPos << endl;
        _debugLevel1("positionLeftArm: " << ballPos << ", " << shoulderPos);
        if (ballPos.getX() < 0.0 && target.getZ() > 0.5 && target.getZ() < 5.0)//&& ballPos.getY() < 10.0) //&& ballPos.getZ() > 2.0)
       	    return capable(true);
        else
         	  return capable(false);

      }

  return capable(true);
}
