#include "positionarm.ih"

void PositionArm::preGenerateGoal(unsigned step)
{
  AgentModel& am = SAgentModel::getInstance();
  Vector3D target = Vector3D(0.0,0.0,0.0);
  Matrix4D shoulderTransform = am.getBodyPart(d_side == Types::RIGHT ? Types::RHAND1 : Types::LHAND1)->transform;
  Vector3D target_temp = d_goal->getVector("Target");
  Vector3D shoulderPos = shoulderTransform.trans() + shoulderTransform.front();
  //Vector3D toePos = footTransform.trans() + footTransform.front() * 0.956 / 2.0;
  cerr << "shoulderpos: " << shoulderPos << endl;
  cerr << "target_temp: " << target_temp << endl;
  shoulderPos.setZ(0);

  
  if (target_temp.getZ() > 4.0)
  {
	  target = shoulderPos + Vector3D(0.0,0.0,4.0);
	  cerr << "target_correction: " << target << endl;
  }
  else
  {
	  target = shoulderPos + Vector3D(0.0,0.0,target_temp.getZ());
	  cerr << "geen_target_correction: " << target << endl;
  }

  cerr << "target: " << target << endl;

  d_speeds[0] = 0;
  for (unsigned i = 1; i < 5; ++i)
  {

    d_speeds[i] = 0.05 * Talent::calcJointGradient(shoulderPos,
                                                   target,
                                                   (Types::Joint)((d_side == Types::RIGHT ? Types::RARM1 : Types::LARM1) + i));

    //cerr << "speed ARM: " << d_speeds[i] << endl;
  }

  // keep foot straight
  //d_speeds[3] = -d_speeds[0] - d_speeds[2];
}

