#ifndef _BATS_POSITIONFOOT_HH_
#define _BATS_POSITIONFOOT_HH_

#include "behavior.hh"
#include "worldmodel.hh"

namespace bats
{
  class PositionFoot : public Behavior
  {
    Types::Side d_side;
    
    double d_speedFactor;
    double d_maxDist;
    double d_speeds[5];
    
    Vector3D getToePos();
    
    virtual void preGenerateGoal(unsigned step);
    
    virtual rf<Goal> generateGoal(unsigned step, unsigned slot);
    virtual rf<State> getCurrentState();
    virtual ConfidenceInterval getCapability(rf<State> s, rf<Goal> g);
  
  public:
    PositionFoot(std::string const &id, std::string const &playerClass);
    
    virtual void update();
  };
};

#endif
