#include "remotecontrol.ih"

rf<Behavior::Goal> RemoteControl::generateGoal(unsigned step, unsigned slot)
{
  rf<Goal> goal = new Goal();
  rf<OrNode> dis = goal->addDisjunct();
  rf<AndNode> con = dis->addConjunct();
  
  for (unsigned i = 0; i < Types::NJOINTS; ++i)
  {
    double f = 1.0;
    
    if (i >= Types::LLEG1 && i <= Types::LLEG6)
      f = d_factor > 0 ? 1.0 : 1.0 - fabs(d_factor);
    else if (i >= Types::RLEG1 && i <= Types::RLEG6)
      f = d_factor < 0 ? 1.0 : 1.0 - fabs(d_factor);
    
    ostringstream jout;
    jout << "Factor" << i;
    
    con->addVar(jout.str(), f, f);
  }
  return goal;
}
