#include "score.ih"


Score::Score(string const &id, string const &playerClass)
  : Behavior("Score", id, playerClass)
{
  d_ballDistX = getParam("/balldist/@x", 0.055);
  d_ballDistY = getParam("/balldist/@y", 0.16);
  d_max_distance = getParam("/distance/@max", 4.0);
  d_min_opp_distance = getParam("/distance/@minopp", 0.5);
  d_min_distance = getParam("/distance/@min", 0.7);
  d_last_time = 0;
  d_goal_no = 0;
  
  d_tree = new AST::Node(sequenceType);
  d_tree->addChild(new AST::Node(andType));
  d_tree->getChild(0)->addChild(new AST::Node(orType));
  d_tree->getChild(0)->addChild(new AST::Node(orType));
  d_tree->addChild(new AST::Node(andType));
  d_tree->getChild(1)->addChild(new AST::Node(orType));
  d_tree->getChild(1)->addChild(new AST::Node(orType));
  d_tree->getChild(1)->addChild(new AST::Node(orType));

  d_max_time = getParam("/time/@max", 3.0);
}

