#include "scalablesine.ih"

void ScalableSine::preGenerateGoal(unsigned step)
{
  Sine::preGenerateGoal(step);
  
  //  WorldModel& wm = SWorldModel::getInstance();
  
  for (unsigned i = 0; i < Types::NJOINTS; ++i)
  {
    ostringstream jout;
    jout << "AmpFactor" << i;
    _debugLevel1("Goal has " << jout.str() << ": " << (d_goal->findDeep(jout.str()) ? "yes" : "no"));
    if (d_goal->findDeep(jout.str()))
    {
      double f = d_goal->getMean(jout.str());
      _debugLevel1("AmpFactor: " << f);
      for (unsigned s = 0; s < d_jointparams[i]->sines.size(); ++s)
        rf_cast<ScalableJointParams>(d_jointparams[i])->ampFactors[s] = f;
    }
    else
    {
      for (unsigned s = 0; s < d_jointparams[i]->sines.size(); ++s)
      {
        rf_cast<ScalableJointParams>(d_jointparams[i])->ampFactors[s] = 1;
        ostringstream jout2;
        jout2 << "AmpFactor" << i << "-" << s;
        _debugLevel1("Goal has " << jout2.str() << ": " << (d_goal->findDeep(jout2.str()) ? "yes" : "no"));
        if (d_goal->findDeep(jout2.str()))
        {
          double f = d_goal->getMean(jout2.str());
          _debugLevel1("f: " << f);
          rf_cast<ScalableJointParams>(d_jointparams[i])->ampFactors[s] = f;
        }
      }
    }
    
    if (d_goal->findDeep("FreqFactor"))
    	d_jointparams[i]->freqfactor = d_goal->getMean("FreqFactor");
  }
}

