#ifndef _BATS_SCALABLESINE_HH_
#define _BATS_SCALABLESINE_HH_

#include "../sine.hh"

namespace bats
{
  class ScalableSine : public Sine
  {
  public:
    struct ScalableJointParams : public JointParams
    {
      ScalableJointParams(rf<JointParams> p)
      {
        joint = p->joint;
        sines = p->sines;
        freqfactor = p->freqfactor;
      }

			std::vector<double> ampFactors;
    };
    
  private:
    std::string d_syncWith;
    
    virtual void preGenerateGoal(unsigned step);
		virtual double calcAngle(unsigned slot);
    
  public:
    ScalableSine(std::string const &id, std::string const &playerClass)
    : Sine(id, playerClass)
    {
      d_syncWith = Behavior::getParam("/syncWith", std::string(""));
      
      for (unsigned i = 0; i < d_jointparams.size(); ++i)
      {
        ScalableJointParams* p = new ScalableJointParams(d_jointparams[i]);
        for (unsigned s = 0; s < p->sines.size(); ++s)
          p->ampFactors.push_back(1.0);
        d_jointparams[i] = p;
      }
    }
  };
}

#endif

