#include "sine.ih"

double Sine::calcAngle(unsigned slot)
{
	//WorldModel& wm = WorldModel::getInstance();
	//_debugLevel1("StartTime: " << jointparams.startTime);

	double angle = 0;
	rf<JointParams> params = d_jointparams[slot];

	// Iterate over all sines
	for (vector<SineParams>::iterator iter = params->sines.begin(); iter != params->sines.end(); ++iter)
	{
		SineParams &parameters = *iter;
		angle += params->joint.amplitude() * parameters.amplitude *
             sin(params->joint.sampleTime() / parameters.period * 2 * M_PI + parameters.phase) +
             parameters.offset;
	}
  
	angle *= M_PI / 180.0;
	return angle;
}

