#include "sine.ih"

rf<Behavior::Goal> Sine::generateGoal(unsigned step, unsigned slot)
{
	WorldModel& wm = SWorldModel::getInstance();
  AgentModel& am = SAgentModel::getInstance();
  
  double angle = 0;
	double total = 0;
  
	//_debugLevel1("s_sines.size(): " << s_sines.size() << " slot: " << slot);
	
	// Calculate the sum of all the angles for all the sinusoids
	for (unsigned i = 0; i < s_sines.size(); ++i)
	{
		if (d_smoothTransfer)
    {
      _debugLevel3("Using smooth transfer. Sine: " << i << " (" << s_sines[i]->ident() << "), slot: " << slot << ", factor: " << s_sines[i]->getFactor());
      angle += s_sines[i]->getFactor() * s_sines[i]->calcAngle(slot);
      total += s_sines[i]->getFactor();
    }
    else
    {
      rf<Sine::JointParams> jointParams = s_sines[i]->getJointParams()[slot];
      if (jointParams->joint.active())
      {
        /*if (jointParams.factor > 0)
          _debugLevel3("Running sine[" << i <<"] : " << s_sines[i]->ident() << " " << wm.getTime() << " " << jointParams.factor);*/
        
        angle += calcAngle(slot); //jointParams.factor * calcAngle(slot);
        total += 1.0; //jointParams.factor;
      }
    }
	}
  
  _debugLevel1(wm.getTime() << " Total angle: " << angle << ", factor: " << total);
	if (total > 1)
		angle /= total;
	else
	  if (slot == Types::LARM1 || slot == Types::RARM1)
	    angle += (1.0 - total) * -90.0 / 180.0 * M_PI;
	    

	rf<Goal> goal = new Goal();
	rf<OrNode> dis = goal->addDisjunct();
	rf<AndNode> con = dis->addConjunct();

	_debugLevel1(am.getJoint(Types::LARM1)->angle.getMu() << " " << slot << " angle: " << angle);
	con->addVar("Angle", angle, angle);

	s_lastSineTime = wm.getTime();

	return goal;
}

