#include "sine.ih"

double
Sine::startPosition(Types::Joint joint)
{
	double angle = 0;
	rf<JointParams> params = d_jointparams[joint];

	// Iterate over all sines
	for (vector<SineParams>::iterator iter = params->sines.begin(); iter != params->sines.end(); ++iter)
	{
		SineParams &parameters = *iter;
		double a = parameters.amplitude * sin(parameters.phase);
		
		if (params->joint.modulationSpan() != 0 && params->joint.amplitudeModulation())
			a *= params->joint.amplitudeStart();

		a += parameters.offset;

		angle += a;
	}

	return angle * (M_PI / 180.0);
}
