#ifndef _BATS_STABILIZE_HH_
#define _BATS_STABILIZE_HH_

#include "behavior.hh"

#define NO_OF_STABILIZE_ARGS 6

#define NO_OF_TRIES_THRESHOLD 0

  
namespace bats
{
  class Stabilize : public Behavior
  {
	bool d_wasCommitted;
	int d_noOfTries;
	bool d_isNearlyStabilized;
	
	float d_stabilizeSpeed, d_counterAngleWeight, d_counterOffsetAngle, d_maxAngle, d_stabilizeThreshold, d_stabilizeAngleWeight;
	
    virtual rf<Goal> generateGoal(unsigned step, unsigned slot);
    virtual rf<State> getCurrentState();
    virtual ConfidenceInterval getCapability(rf<State> s, rf<Goal> g);
  
  public:
    Stabilize(std::string const &id, std::string const &playerClass);
    
    void update();
  };
};

#endif
