#include "stabilize.ih"

void Stabilize::update()
{
  Behavior::update();
  
   	ifstream infile; 
  	infile.open("stabilizeWeights", ios::out);
  	
  	string argNames[NO_OF_STABILIZE_ARGS];
  	string argValues[NO_OF_STABILIZE_ARGS]; 
  	
  	for (int idx = 0; idx < NO_OF_STABILIZE_ARGS; ++idx)
  		infile >> argNames[idx] >> argValues[idx];
  	
  	for (int idx = 0; idx < NO_OF_STABILIZE_ARGS; ++idx)
    {    
    	if (argNames[idx] == "StabilizeSpeed")
    		d_stabilizeSpeed = atof(argValues[idx].c_str());
    	else if (argNames[idx] == "CounterAngleWeight")
    		d_counterAngleWeight = atof(argValues[idx].c_str());
    	else if (argNames[idx] == "CounterAngleOffset")
    		d_counterOffsetAngle = atof(argValues[idx].c_str());
    	else if (argNames[idx] == "MaxAngle")
    		d_maxAngle = atof(argValues[idx].c_str());	
    	else if (argNames[idx] == "StabilizeThreshold")
    		d_stabilizeThreshold = atof(argValues[idx].c_str());	
    	else if (argNames[idx] == "StabilizeAngleWeight")
    		d_stabilizeAngleWeight = atof(argValues[idx].c_str());	
    	//else if (argNames[idx] == "Wait")
    		//d_wait = atof(argValues[idx].c_str());
    	else
    		_debugLevel1("WARNING: Unknown argument in stabilize-file (trunk/stabilizeWeight) ");    		
    }
    
    infile.close(); 
  
  WorldModel& wm = SWorldModel::getInstance();
  AgentModel& am = SAgentModel::getInstance();
  
  //d_committed = d_committed || (!wm.onMyBack() && !wm.onMyBelly() && abs(wm.getDistToField()) > 1.0) && wm.getGyro().length() > 1;
  d_committed = d_committed || (!am.onMyBelly() && !am.onMySide() && !am.onMyBack() && !(wm.getFieldNormal().getY() > -0.05 && wm.getFieldNormal().getY() < 0.05 && am.onMyFeet() &&  wm.getFieldNormal().getY() < 0.05 && am.getGyro().length() < 0.1));
  
  if (d_committed)
  {
  	d_wasCommitted = true;
  	_debugLevel4("Commit" << d_committed <<" " << am.onMyBelly() << am.onMyFeet() << am.onMyBack() << " " << am.getGyro().length());
  }
  
  if (!d_committed && d_wasCommitted)
  {
  	/*ifstream infile; 
  	infile.open("stabilizeWeights", ios::out | ios::in );
  	infile.close();*/
  	
  	d_wasCommitted = false;
  	
  	if ((wm.getFieldNormal().getY() > -0.05 && !wm.getFieldNormal().getY() < 0.05 && am.onMyFeet() &&  wm.getFieldNormal().getY() < 0.05 && am.getGyro().length() < 0.1)) 
  	{
  		_debugLevel1("Succes."); 
  		d_noOfTries = 0;
    }
  	else
  	{
  	  if (d_noOfTries > NO_OF_TRIES_THRESHOLD)
  	    wm.setGetUpTheOldFashionedWay(true);
  	    
  		_debugLevel1("Failed to get up. Tries: " << d_noOfTries);
  		++d_noOfTries;
  	}  	
  }
  		
  	
}

