#include "steer.ih"

Steer::Steer(string const &id, string const &playerClass)
  : Behavior("Steer", id, playerClass)
{
  d_strength = Behavior::getParam("/strength", 0.5);

  d_min_distance = Behavior::getParam("/distance/@min", 0.25);

  d_tree = new AST::Node(sequenceType);
  d_tree->addChild(new AST::Node(andType));
  d_tree->getChild(0)->addChild(new AST::Node(orType));
    d_tree->addChild(new AST::Node(andType));
  d_tree->getChild(1)->addChild(new AST::Node(orType));
    d_tree->addChild(new AST::Node(andType));
  d_tree->getChild(2)->addChild(new AST::Node(orType));

  d_minUpdateAngleThreshold = Behavior::getParam("/update_angleThreshold/@min", 60.0);  
  d_maxUpdateAngleThreshold = Behavior::getParam("/update_angleThreshold/@max", 90.0);
  d_rangeUpdateAngleThreshold = Behavior::getParam("/update_angleThreshold/@range", 5.0);
  
  d_minCapableAngleThreshold = Behavior::getParam("/capable_angleThreshold/@min", 20.0);  
  d_maxCapableAngleThreshold = Behavior::getParam("/capable_angleThreshold/@max", 80.0);
  d_rangeCapableAngleThreshold = Behavior::getParam("/capable_angleThreshold/@range", 1.5);

}
