#include "steer.ih"

Behavior::ConfidenceInterval Steer::getCapability(rf<State> s, rf<Goal> g)
{
		
	if (g->findDeep("PosX"))
	{
		Vector3D pos = g->getVector("Pos");
		pos.setZ(0);
  	float angle = atan2(pos[0], pos[1]);
  	angle = (angle * 360) / (2 * M_PI);
		
		float distance = pos.length();
		
		float slope = (d_maxCapableAngleThreshold - d_minCapableAngleThreshold) / d_rangeCapableAngleThreshold ;
		
		float currentThreshold = d_minCapableAngleThreshold + slope * distance;
		
		if (currentThreshold > d_maxCapableAngleThreshold)
			currentThreshold = d_maxCapableAngleThreshold;
		
		
		_debugLevel1("STEER = angle: " << angle << "  THRESH: " << currentThreshold	<< " Poslength: " << pos.length());
		//_debugLevel1("capablesteer: " << capable(pos.length() > d_min_distance && fabs(angle) <= currentThreshold).first	);
		
		if (pos.length() > d_min_distance && fabs(angle) <= currentThreshold)	
			return capable(true);
	}
	else
		_debugLevel1("WARNING: Goal->Angle not specified!");
	 
  return capable(false);
}
