#include "steer.ih"

void Steer::update()
{
  Behavior::update();
	WorldModel& wm = SWorldModel::getInstance();
	if (d_goal)
	{
    	
		Vector3D pos = wm.getObject(Types::BALL).position.getMu();
		if (d_goal->findDeep("PosX"))
		  pos = d_goal->getVector("Pos");		
		  
		float angle = 0;
		if (d_goal->findDeep("Angle"))
		  angle = d_goal->getMean("Angle");
		
		float distance = pos.length();
		
		float slope = (d_maxUpdateAngleThreshold - d_minUpdateAngleThreshold) / d_rangeUpdateAngleThreshold ;
		
		float currentThreshold = d_minUpdateAngleThreshold + slope * distance;
		
		if (currentThreshold > d_maxUpdateAngleThreshold)
			currentThreshold = d_maxUpdateAngleThreshold;
		
		d_committed = d_committed || (pos.length() > d_min_distance) && (currentThreshold > fabs(angle));
	}
	
}
  
