#include "tactic.ih"

rf<Behavior::Goal> Tactic::generateGoal(unsigned step, unsigned slot)
{
  rf<Goal> goal = new Goal();
  rf<OrNode> dis = goal->addDisjunct();
  rf<AndNode> con = dis->addConjunct();

  AgentModel &am = SAgentModel::getInstance();
  WorldModel &wm = SWorldModel::getInstance();

    if (d_current)
        {
            double angle1 = -d_current->firstPlayerAngle();
            double angle2 = -d_current->secondPlayerAngle();
            
            size_t laagsteBovenEen = 999;

            WorldModel::player_iterator it = wm.beginPlayers();
            WorldModel::player_iterator end = wm.endPlayers();

            for (; it != end; ++it)
                if (it->first > 0) //unums staan 1 te laag
                {
                    laagsteBovenEen = it->first;
                    break;
                }

            if (am.getUnum() < laagsteBovenEen) //your first
            {
                con->addVar("Pos", d_current->firstPlayerPos());

                if (d_current->firstPlayerScore())
                {
                   con->addVar("Dir", Vector3D(cos(angle1), sin(angle1), 0.0));
                }
                else
                {
                   con->addVar("Dir", Vector3D(cos(angle1), sin(angle1), 0.0) );
                    con->addVar("Angle", angle1, angle1);
                    con->addVar("SurpressScore", 1, 1);
                }            
            }
            else
            {
                con->addVar("Pos", d_current->secondPlayerPos());          

                if (d_current->secondPlayerScore())
                {
                    con->addVar("Dir", Vector3D(cos(angle2), sin(angle2), 0.0));
                }
                else
                {
                    con->addVar("Dir", Vector3D(cos(angle2), sin(angle2), 0.0));
                    con->addVar("SurpressScore", 1, 1);
                    con->addVar("Angle", angle2, angle2);        
                }
            }
        }
    else
    {
        con->addVar("Pos", Vector3D(0, 0, 0));
        con->addVar("Dir", Vector3D(0.0, 1.0, 0.0));
    }
	return goal;
}
