#ifndef _INCLUDED_TACTIC_
#define _INCLUDED_TACTIC_

#include "tacticset/tacticset.h"
#include "Vector3/vector3.hh"
#include <vector>
#include "behavior.hh"

namespace bats
{
class Tactic : public Behavior
{
    
    std::vector<TacticSet *> d_tactic_sets;
    TacticSet *d_current;

    typedef std::vector<TacticSet *>::iterator TacticIterator;

    public:
        Tactic(std::string const &id, std::string const &playerClass);

    private:

    virtual rf<Goal> generateGoal(unsigned step, unsigned slot);
    virtual rf<State> getCurrentState();
    virtual ConfidenceInterval getCapability(rf<State> s, rf<Goal> g);

  public:
    virtual void update();
};

}
#endif
