#include "kicktrainer.ih"

void KickTrainer::preGenerateGoal(unsigned step)
{
  Cochlea& cochlea = SCochlea::getInstance();
  AgentModel& am = SAgentModel::getInstance();
  WorldModel& wm = SWorldModel::getInstance();
  
  Vector3D worldRight = Math::polarToCartesian(cochlea.getInfo(Cochlea::iVisionFlag1R)) - Math::polarToCartesian(cochlea.getInfo(Cochlea::iVisionFlag1L));
  Vector3D worldForward = Math::polarToCartesian(cochlea.getInfo(Cochlea::iVisionFlag1L)) - Math::polarToCartesian(cochlea.getInfo(Cochlea::iVisionFlag2L));
  Vector3D worldUp = worldRight.crossProduct(worldForward);

  Matrix4D worldTransform(worldRight.normalize(), worldForward.normalize(), worldUp.normalize());
  Matrix4D invWorldTransform = worldTransform.inverse();
  
  cout << "(KickTrainer) " << wm.getTime() << " lfoot: " << am.getBodyPart(Types::LFOOT)->transform.trans() << endl;
  cout << "(KickTrainer) " << wm.getTime() << " rfoot: " << am.getBodyPart(Types::RFOOT)->transform.trans() << endl;
  cout << "(KickTrainer) " << wm.getTime() << " ball: " << invWorldTransform * Math::polarToCartesian(cochlea.getInfo(Cochlea::iVisionBall)) << endl;
  cout << "(KickTrainer) " << wm.getTime() << " flag: " << invWorldTransform * Math::polarToCartesian(cochlea.getInfo(Cochlea::iVisionFlag1L)) << endl;
}

