#include "trainer.ih"

bool Trainer::achieveGoal()
{
  Cerebellum& cer = SCerebellum::getInstance();
  TrainerSocketComm& comm = STrainerSocketComm::getInstance();
  
  switch (d_stage)
  {
    case RESET:
      
      reset();

      break;
    
    case START1:
    	cer.addAction(new Cerebellum::BeamAction(d_agentStartPos));
      resetJoints();
      break;
      
    case START2:

      // Set ball at start pos
      comm.setBallPos(d_ballStartPos);
      
      comm.setPlayMode(d_playMode);
      break;
      
    case STOP:
      comm.setPlayMode(Types::BEFORE_KICKOFF);
    
      resetJoints();
      break;
      
    case RUN:
      return Behavior::achieveGoal();
  }
  //assert(false);//Must hit one of the stages, or we have a BIG problem
  return true;
}

