#ifndef _BATS_TRAINER_HH_
#define _BATS_TRAINER_HH_

#include "primitivebehavior.hh"
#include "trainersocketcomm.hh"

namespace bats
{
  class Trainer : public Behavior
  {
    enum Stage
    {
      RESET,
      START1,
      START2,
      RUN,
      STOP
    };
    
    Stage d_stage;
    
    Vector3D d_minBallStartPos;
    Vector3D d_maxBallStartPos;
    
    Vector3D d_minAgentStartPos;
    Vector3D d_maxAgentStartPos;
    
    Vector3D d_ballStartPos;
    Vector3D d_agentStartPos;
    
    double d_runTime;
    
    double d_runStartTime;
    
    Types::PlayMode d_playMode;
    
    virtual rf<Goal> generateGoal(unsigned step, unsigned slot);
    virtual rf<State> getCurrentState();
    virtual ConfidenceInterval getCapability(rf<State> s, rf<Goal> g);
  
    virtual void onRunStart() {}
    virtual void onRunEnd() {}
    
    void resetJoints();
    
  public:
    Trainer(std::string const &id, std::string const &playerClass);
    
    virtual void update();

    virtual bool achieveGoal();
  };
};

#endif

