#include "trainer.ih"

void Trainer::update()
{
  Behavior::update();
  
  STrainerSocketComm::getInstance().update();
  
  _debugLevel1("(Trainer::update) stage: " << d_stage);
  
  WorldModel& wm = SWorldModel::getInstance();
  
  if (d_runStartTime == -1)
    d_runStartTime = wm.getTime() - d_runTime - 2;
  
  if (d_stage == START1)
    d_stage = START2;
      
  if (d_stage == RESET)
  {
    // Determine ball and agent start pos
    d_ballStartPos = d_minBallStartPos;
    for (unsigned i = 0; i < 3; ++i)
      d_agentStartPos[i] = d_minAgentStartPos[i] + (d_maxAgentStartPos[i] - d_minAgentStartPos[i]) * rand() / (RAND_MAX + 1.0);
    _debugLevel1("(Trainer::update) Beam pos: " << d_agentStartPos);
    d_stage = START1;
  }
  
  if (d_stage == START2 && wm.getTime() - d_runStartTime >= d_runTime + 4)
  {
    d_runStartTime = wm.getTime();
    onRunStart();
    d_stage = RUN;
  }
    
  if (d_stage == RUN && wm.getTime() - d_runStartTime >= d_runTime)
  {
    d_stage = STOP;
    onRunEnd();
  }
  
  if (d_stage == STOP && wm.getTime() - d_runStartTime >= d_runTime + 2)
    d_stage = RESET;
}


