#include "transition.ih"

Transition::Transition(string const &id, string const &playerClass)
:
	Behavior("Transition", id, playerClass),
	d_for(0),
	d_forid(""),
	d_startTime(-1),
	d_period(0),
	d_capable(false)
{
	d_period = Behavior::getParam("/period", d_period);
	
	if (d_period < 0)
		_debugLevel1("Warning: period is negative!");
	
	XMLNode node = Behavior::getParam("/for");

	if (node) 
		d_forid = node.getContent();

	_debugLevel1("Transition into behavior: " << d_forid);

	d_tree = new AST::Node(sequenceType);
	d_tree->addChild(new AST::Node(andType));
	
	// Add plenty
	for (size_t i = 0; i < Types::NJOINTS; ++i)
		d_tree->getChild(0)->addChild(new AST::Node(orType));
}

