#include "turnto.ih"

void TurnTo::update()
{
  Behavior::update();

  if (!d_goal)
    d_committed = false;
  else
  {
    rf<StateVarNode> angleNode;
    
    angleNode = rf_cast<StateVarNode>(d_goal->findDeep("Angle"));
    
    if(angleNode)
    {
      double angle = angleNode->getVar().second.mean() / M_PI * 180;
      _debugLevel1("Angle in turnto: " << angle);
      d_committed = fabs(angle) > 5.0;
    }
    else
      d_committed = false;
  }
}

