#include "waitforopponent.ih"

rf<Behavior::Goal> WaitForOpponent::generateGoal(unsigned step, unsigned slot)
{
  double extra_distance = 2.7;
  
  rf<Goal> goal = new Goal();
  rf<OrNode> dis = goal->addDisjunct();
  rf<AndNode> con = dis->addConjunct();
  
  WorldModel& wm = SWorldModel::getInstance();
  Vector3D pos;
  
  Vector3D fieldCenter = (wm.getObject(Types::GOAL1R).position.getMu() + wm.getObject(Types::GOAL2L).position.getMu()) / 2;
  Vector3D fieldDir = (wm.getObject(Types::GOAL1US).position.getMu() - wm.getObject(Types::GOAL1THEM).position.getMu()).normalize();
  Vector3D ballPos = wm.getObject(Types::BALL).position.getMu();
  Vector3D goalCenter = (wm.getObject(Types::GOAL1US).position.getMu() + wm.getObject(Types::GOAL2US).position.getMu()) / 2;
  Vector3D goalBallDir = (ballPos - goalCenter).normalize();

  Vector3D straight(0, 1, 0);
  double angle = straight.angle(goalBallDir);
  if (goalBallDir.getY() > 0)
    angle = -angle;
  
  /*switch (wm.getPlayMode())
  {
    case Types::KICKOFF_THEM:
      pos = fieldCenter + fieldDir * 5;
      break;
      
    case Types::GOAL_KICK_THEM:
    case Types::CORNER_KICK_THEM:
    case Types::FREEKICK_THEM:
    case Types::KICKIN_THEM:
    default:
      break;
  }*/
  
  Vector3D friend_pos = wm.getObject(Types::PLAYER1).position.getMu();
  double friend_ball_distance = (friend_pos - ballPos).length();
  if (ballPos.length() < friend_ball_distance)
    pos = ballPos - goalBallDir * d_wait_distance;
  else
    pos = ballPos - goalBallDir * (d_wait_distance + extra_distance);
  
  con->addVar("Pos", pos);
  con->addVar("Angle", angle, angle);
  // con->addVar("Var", 0, 1);
  
  return goal;
}
