#include "waitforopponent.ih"

Behavior::ConfidenceInterval WaitForOpponent::getCapability(rf<State> s, rf<Goal> g)
{
  WorldModel& wm = SWorldModel::getInstance();
  AgentModel& am = SAgentModel::getInstance();
  
  Vector3D ballPos = wm.getObject(Types::BALL).position.getMu();
  Vector3D otherPos = (am.getUnum() == 1 ? wm.getObject(Types::PLAYER3).position.getMu() : wm.getObject(Types::PLAYER2).position.getMu());
  ballPos[2] = otherPos[2] = 0;
  
  _debugLevel1(am.getUnum() << " " << ballPos << " " << otherPos);
  switch (wm.getPlayMode())
  {
    case Types::KICKOFF_THEM: 
    case Types::CORNER_KICK_THEM: 
    case Types::GOAL_KICK_THEM:
    case Types::FREEKICK_THEM: 
    case Types::KICKIN_THEM: 
      return ConfidenceInterval(0.9, 0.0);
      
    default:
      if ((ballPos - otherPos).length() < ballPos.length())
        return ConfidenceInterval(0.9, 0.0);
      else
        return capable(false); 

    
  }
}
