#include "waitforopponent.ih"

void WaitForOpponent::getSettings()
{
  XMLNodeSet params = Behavior::getParams("/settings");
  istringstream paramReader;
  if(params && !params.empty())
  {
    XMLNode paramNode = params.front();
    paramReader.str(paramNode.getContent());

    while (!paramReader.eof())
    {
      _debugLevel1("Reading new line..");
      string setting;
      char punc;
      
      paramReader >> setting;
      if (setting[setting.size() - 1] != '=')
      {
        paramReader >> punc;
        if (punc != '=')
        {
          _debugLevel1("Wrong format: '" << punc << "', expected '='");
          break;
        }
      }
      
      if (setting == "waitDistance")
      {
        paramReader >> d_wait_distance;
        _debugLevel1("Wait distance: " << d_wait_distance);
      }
    }
  }
  else
  {
    _debugLevel1("no settings parameters found");
  }
}
