#include "walkaroundgoal.ih"
#include "math.hh"

rf<Behavior::Goal> WalkAroundGoal::generateGoal(unsigned step, unsigned slot)
{
	WorldModel &wm = SWorldModel::getInstance();

  rf<Goal> goal = new Goal();
  rf<OrNode> dis = goal->addDisjunct();
  rf<AndNode> con = dis->addConjunct();

    Vector3D back = (wm.getObject(Types::GOAL1US).position.getMu() - wm.getObject(Types::GOAL1THEM).position.getMu()).normalize();

    double goal_width = 0.4;

    Vector3D goal1 = wm.getObject(Types::GOAL1US).position.getMu();    
    Vector3D goal2 = wm.getObject(Types::GOAL2US).position.getMu();

    Vector3D goal1_back = goal1 + back * goal_width; 
    Vector3D goal2_back = goal2 + back * goal_width;

	Vector3D toOpponent = (wm.getObject(Types::GOAL1THEM).position.getMu() - wm.getObject(Types::GOAL1US).position.getMu()).normalize();
    Vector3D toRight = (wm.getObject(Types::GOAL2US).position.getMu() - wm.getObject(Types::GOAL1US).position.getMu()).normalize();
  
    bool achter_achterste_paal = goal1_back.dotProduct(toOpponent) > 0.0; //achter achterste paal van doel
    bool closer_to_1 = goal1_back.length() < goal2_back.length();
    bool tussen_achter_palen = ((goal1.dotProduct(toRight) > 0.0) && (goal2.dotProduct(toRight) < 0.0)) ||
                                ((goal1.dotProduct(toRight) < 0.0) && (goal2.dotProduct(toRight) > 0.0));

    Vector3D pos;

    if (tussen_achter_palen)
    {
        if (closer_to_1 && !achter_achterste_paal)
            pos = toRight * -3.0;
        else
            pos = toRight * 3.0;
    }
    else
        pos = toOpponent * 3.0;

    con->addVar("Pos", pos);
    con->addVar("Dir", pos.normalize());

  return goal;
}

