#include "walkaroundgoal.ih"
#include "math.hh"

Behavior::ConfidenceInterval WalkAroundGoal::getCapability(rf<State> s, rf<Goal> g)
{
	WorldModel &wm = SWorldModel::getInstance();

    Vector3D back = (wm.getObject(Types::GOAL1US).position.getMu() - wm.getObject(Types::GOAL1THEM).position.getMu()).normalize();

    double goal_width = 0.4;

    Vector3D goal1 = wm.getObject(Types::GOAL1US).position.getMu();    
    Vector3D goal2 = wm.getObject(Types::GOAL2US).position.getMu();

    Vector3D goal1_back = goal1 + back * goal_width; 
    Vector3D goal2_back = goal2 + back * goal_width;

	Vector3D toOpponent = (wm.getObject(Types::GOAL1THEM).position.getMu() - wm.getObject(Types::GOAL1US).position.getMu()).normalize();
    Vector3D toRight = (wm.getObject(Types::GOAL2US).position.getMu() - wm.getObject(Types::GOAL1US).position.getMu()).normalize();

    bool achter_de_lijn = goal1.normalize().dotProduct(toOpponent) > 0.4;  //achter de lijn
    bool achter_achterste_paal = goal1_back.dotProduct(toOpponent) > 0.0; //achter achterste paal van doel
    bool tussen_achter_palen = ((goal1.dotProduct(toRight) > 0.0) && (goal2.dotProduct(toRight) < 0.0)) ||
                                ((goal1.dotProduct(toRight) < 0.0) && (goal2.dotProduct(toRight) > 0.0));

    bool dicht_bij_goal = ((goal1 + goal2) / 2.0).length() < 3.0;

    bool closer_to_1 = goal1_back.length() < goal2_back.length();

    if (achter_de_lijn && dicht_bij_goal && !(tussen_achter_palen && !achter_achterste_paal))
        return capable(true);
    else
        return capable(false);
}

