#include "walkoutgoal.ih"
#include "math.hh"



rf<Behavior::Goal> WalkOutGoal::generateGoal(unsigned step, unsigned slot)
{
  rf<Goal> goal = new Goal();
  rf<OrNode> dis = goal->addDisjunct();
  rf<AndNode> con = dis->addConjunct();
  
  // con->addVar("Var", 0, 1);

	WorldModel &wm = SWorldModel::getInstance();
	Vector3D pos;
	float brakeDist = 1., targetSpeed = 0.;
	
	if (d_goal->findDeep("PosX"))
    pos = d_goal->getVector("Pos");
  else
  {
  	_debugLevel1("No goal specified, using " << Types::nameOf(d_defaultTarget) << " as target.");
		pos = wm.getObject(d_defaultTarget).position.getMu();
	}
		
	if (d_goal->findDeep("BrakeDistance"))
    brakeDist = d_goal->getMean("BrakeDistance");

	if (d_goal->findDeep("TargetSpeed"))
		targetSpeed = d_goal->getMean("TargetSpeed");

	Vector3D finalGoal;
	if (d_goal->findDeep("FinalPosX"))
		finalGoal = d_goal->getVector("FinalPos");
	else
		finalGoal = pos;	
		
	float angle = atan2(pos[0], pos[1]) / M_PI * 2;
	
	con->addVar("Angle", angle, angle);

	
//	float amplitudeMod = exp(-angle*angle*0.001);
	float amplitudeMod = 1.;

	
//	_debugLevel1("Threshold " << threshold << "  angle " << angle);
	
//	con->addVar("ThresholdAngle", threshold, threshold);

	if (d_goal->findDeep("BrakeDistance"))
	  brakeDist = d_goal->getMean("BrakeDistance");

	if (d_goal->findDeep("TargetSpeed"))
      targetSpeed = d_goal->getMean("TargetSpeed");

    if (finalGoal.length() < brakeDist)
	{
	  //moet nog e-macht functie gebruikt worden ipv lineaire downscaling
      if (d_goal->findDeep("SlowOnAngle"))
        amplitudeMod = Math::sigmoid(1 - (min(angle, 65.0f) / 65.0f), 1., targetSpeed, d_goal->getMean("SlowOnAngle"));
	  else
	    amplitudeMod = Math::sigmoid(1 - finalGoal.length() / brakeDist, 1., targetSpeed);
    }

	con->addVar("AmplitudeMod", amplitudeMod, amplitudeMod);
	con->addVar("Pos", pos);
	con->addVar("FinalPos", finalGoal);
  
  return goal;
}

