#include "walktoangle.ih"
#include "math.hh"

rf<Behavior::Goal> WalkToAngle::generateGoal(unsigned step, unsigned slot)
{
  rf<Goal> goal = new Goal();
  rf<OrNode> dis = goal->addDisjunct();
  rf<AndNode> con = dis->addConjunct();
	
  //Necessary goals:
  Vector3D pos, dir;

  if (d_goal->findDeep("PosX") && d_goal->findDeep("DirX"))
  {
    pos = d_goal->getVector("Pos");
    dir = d_goal->getVector("Dir");
  }
  else
  {
	_debugLevel1("WARNING: Not all necessary goals found!");
	return goal;
  }
	 
	//Optional goals
	if (d_targetSpeed == -1)
		d_targetSpeed = (d_goal->findDeep("TargetSpeed")) ? d_goal->getMean("TargetSpeed") : 0.0;

	if (d_brakeDistance == -1)
		d_brakeDistance = (d_goal->findDeep("BrakeDistance")) ? d_goal->getMean("BrakeDistance") : 1.0;
	
    //correctIfCollides(Vector3D const &target, Vector3D goal, size_t depth, bool surpressBall, bool onlyPlayers)
    pos = Avoider::correctIfCollides(pos, Vector3D(0, 0, 0), 1, PLAYERS);

	Vector3D walkToPos = pos - dir.normalize() * pos.length()*d_curveFactor;		 
	
	con->addVar("Pos", walkToPos);
	con->addVar("FinalPos", pos);
	con->addVar("TargetSpeed", d_targetSpeed, d_targetSpeed);
	con->addVar("BrakeDistance", d_brakeDistance, d_brakeDistance);

  
  return goal;
}
