#include "behavior.ih"

bool Behavior::achieveGoal()
{
  try {
    try {
      StackCheck::getInstance().wasCalled(d_id, d_name);
    }
    catch(...)
      {}
    _debugLevel1("Achieving goal in behavior " << ident());
    if (!d_tree)
      return true;
    
    bool succes = true;

		if (d_childrenCommitted)
		{
		 
		   _debugLevel1(ident() << " is committed, doing last chosen");
		   succes = doLastChosen();
    }
    else
    {
      d_lastChosen.clear();
      succes = false;
      
      // Try slots in next sequence step (if there is a step left and we are not committed)
      if (d_curStep >= 0)
      {
        _debugLevel1("Doing next step");
        double prevStepStart = d_curStepStart;
        d_curStepStart = SWorldModel::getInstance().getTime();
        succes = doNextStep();
        if (!succes)
          d_curStepStart = prevStepStart;
        else
          _debugLevel1(ident() << " starting first step, start time: " << d_curStepStart);
        
      }
      else
      {
        d_curStep = 0;
        d_curStepStart = SWorldModel::getInstance().getTime();
        _debugLevel1(ident() << " starting first step, start time: " << d_curStepStart);
      }
        
      if (!succes)
      {
        _debugLevel1("Doing current step");
        succes = doCurrentStep();
      }
    }
    if (!succes)
    {
      _debugLevel1(ident() << " failed!");
    }
    return succes;

  } catch (BatsException *e) {
    BATS_CATCH_FRAME(e);
  }
  d_reset = false;
}

