#include "cankickleft.ih"

Behavior::ConfidenceInterval CanKickLeft::getCapability(rf<Behavior::State> s, rf<Behavior::Goal> g)
{
  WorldModel& wm = SWorldModel::getInstance();
  AgentModel& am = SAgentModel::getInstance();
  
  Vector3D ballPos = wm.getObject(Types::BALL).position.getMu();
  Vector3D footPos = am.getBodyPart(Types::LFOOT)->transform.trans();
  
  if (ballPos.getY() > footPos.getY() && ballPos.getY() < footPos.getY() + d_distance_y &&
      ballPos.getX() - footPos.getX() < d_distance_x && ballPos.getX() - footPos.getX() > -d_distance_x)
  {
    _debugLevel4("Can kick left!");
    return ConfidenceInterval(d_standard_capability_high,  d_standard_capability_low );
  }
    
  _debugLevel4("Can't kick left! " << ballPos);
    
  return ConfidenceInterval(-1.0, 0.0);
  /*_debugLevel4("WalkStraightTo::getCapability");
  
  rf<StateVarNode> gameStateNode = rf_cast<StateVarNode>(s->findDeep("GameState"));
  if (!gameStateNode)
  {
    _debugLevel1("WalkStraightTo doesn't understand!");
    return ConfidenceInterval(-1.0, 0.0);
  }
    
  StateVar gameState = gameStateNode->getVar();
  */
  /*WorldModel& wm = SWorldModel::getInstance();
  NormalDistribution3D BallInfo = wm.getObjectPosition(Types::BALL);
  Vector3D ballPosCar = BallInfo.getMu();
  double ballX = ballPosCar.getX();
  double ballY = ballPosCar.getY();
  // Distance from foot to ball (not from camera)
  double distToBall = sqrt(ballX * ballX + ballY * ballY);
  Vector3D ballPosPol = wm.get(WorldModel::iVisionBall);
  double angleToBall = ballPosPol.getY() / M_PI * 180;
  double angle = 20.0;
 
  if (distToBall > 1.5 || angleToBall < -angle || angleToBall > 0)
  {
  	_debugLevel3("Too far to kick.");
    return ConfidenceInterval(-1.0, 0.0);
  }
 	cout << "shieT!" << endl;
 	_debugLevel4("Capable");
  return ConfidenceInterval(0.5, 0.2);
  */
}
