#include "behavior.ih"

void Behavior::createBehaviors()
{
  try {
    Conf& conf = SConf::getInstance();
    //WorldModel& wm = SWorldModel::getInstance();
  	AgentModel const &am = SAgentModel::getInstance();
  
    vector<XMLNode> players;
    string playerClass;
  
    _debugLevel3("Creating behaviors for player " << am.getUnum());
  
    conf.getRoot().findAll(players, "player");
    for (vector<XMLNode>::iterator iter = players.begin(); iter != players.end(); ++iter)
      if (static_cast<unsigned>(atoi(iter->getProp("id").c_str())) == am.getUnum() || atoi(iter->getProp("id").c_str()) == 0)
				playerClass = iter->getProp("class");
    _debugLevel3("Player class: " << playerClass);
  	_flog("Player class: %s", playerClass.c_str());
  
    string path = "/conf/player-class[@id='" + playerClass + "']/behaviors/behavior[@id='win']";
    _debugLevel4(path);
    XMLNodeSet set = conf.selectXPath(path);

    if (set.empty())
      throw runtime_error(string() + "createBehavior: '" + path + "' not found!");

    _debugLevel4(set.size());
    XMLNode win = set.front();
    s_win = buildTree(win, playerClass);

	// Iterate over all behaviors, and call 'constructed'
	for (map<string, rf<Behavior> >::iterator iter = s_behaviors.begin(); iter != s_behaviors.end(); ++iter)
		(iter->second)->constructed();
	
  } catch (BatsException *e) {
    BATS_CATCH_FRAME(e);
    throw;
  }
}
