#include "avoider.ih"

Vector3D Avoider::correct(Vector3D const &target, Vector3D const &obstacle, double radius)
{
  Vector3D orthogonal = obstacle.crossProduct(Vector3D(0, 0, 1)).normalize();
  Vector3D new_target;

  if (target.dotProduct(orthogonal) > 0)
    new_target = obstacle + orthogonal * (factor * radius + my_radius);
  else
    new_target = obstacle - orthogonal * (factor * radius + my_radius);

  _debugLevel4("correcting from: " << target << " to " << new_target << " " << orthogonal << " " << obstacle << " " << radius << " " << my_radius << " " << factor << " o " << obstacle << " t: " <<  (orthogonal *(factor * radius + my_radius)));

  return new_target;
}
