#include "avoider.ih"

Vector3D Avoider::correctIfCollides(Vector3D const &target, Vector3D goal, size_t depth, unsigned check)
{
#ifdef NO_AVOID
    return target;
#endif

  if (depth == 0) //just in case
    return target;

  WorldModel &wm = SWorldModel::getInstance();

  if (goal == Vector3D(0.0, 0.0, 0.0))
     goal = wm.getObject(Types::GOAL1THEM).position.getMu();

  //cout << "bla" << depth << endl;
  double distanceToTarget = target.length();

  if (check & PLAYERS)
  {
    WorldModel::player_iterator it_pl = wm.beginPlayers();
    WorldModel::player_iterator end_pl = wm.endPlayers();

    for (; it_pl != end_pl; ++it_pl)
    {
      Vector3D other = it_pl->second.getPosition();
      if (other == Vector3D(0, 0, 0)) //voor sommige rare situaties wanneer hij denkt dat er mensen zijn die er niet zijn, spooky
        continue;
      if (distanceToTarget > other.length())
        if (collides(target, other, radius_of_dude))
        {
            //cout << "player collides" << endl;
            return correct(target, other, radius_of_dude);//return correctIfCollides(correct(target, other, radius_of_dude), goal, depth - 1, surpressBall, onlyPlayers);
        }
    }
   }

  if(check & ENEMIES)
  {
    WorldModel::player_iterator it_op = wm.beginOpponents();
    WorldModel::player_iterator end_op = wm.endOpponents();

    for (; it_op != end_op; ++it_op)
    {
      Vector3D other = it_op->second.getPosition();
      if (other == Vector3D(0, 0, 0))
	    continue;
      if (distanceToTarget > other.length())
      {
	    if (collides(target, other, radius_of_dude))
        {
            //cout << "opponent collides" << endl;
	        return correct(target, other, radius_of_dude);//return correctIfCollides(correct(target, other, radius_of_dude), goal, depth - 1, surpressBall,onlyPlayers);
        }
      }
    }
  }


  Vector3D other = wm.getObject(Types::BALL).position.getMu();
   //cout << "nu de bal" << depth << " " << distanceToTarget << " " << other.length() << " " <<(distanceToTarget > other.length()) << endl;
  if ((check & BALL) && distanceToTarget > other.length())
  {
     //cout << "zdf" << endl;
     if (collides(target, other, radius_of_ball))
     {
        if ((check & BALL) && goal.normalize().dotProduct(other.normalize()) > -0.1)// && goal.length() > 0.04)
        {
            //cout << "ball collides" << endl;
            return correct(target, other, radius_of_dude);//return correctIfCollides(correct(target, other, radius_of_ball), goal, depth - 1, surpressBall, onlyPlayers);
        }
     }
  }

 //cout << "geen bal" << depth << endl;

  return target;
}
