#ifndef _BATS_COUPLEDSINEFUNCTION_HH_
#define _BATS_COUPLEDSINEFUNCTION_HH_

#include "function.hh"
#include "refable.hh"

namespace bats
{
  class CoupledSineFunction : public Function<double,double>, public RefAble
  {
    double d_amplitude;
    double d_period;
    double d_phaseOffset;
    double d_phase;
    double d_offset;
    double d_coupling;
    
  public:
    CoupledSineFunction(double amplitude, double period, double phaseOffset, double offset, double coupling)
    : d_amplitude(amplitude),
      d_period(period),
      d_phaseOffset(phaseOffset),
      d_phase(phaseOffset),
      d_offset(offset),
      d_coupling(coupling)
    {}
    
    /**
     * @param in Phase of robot dynamics (-atan(x'/x))
     * @returns joint angle in radians
     */
    virtual double operator()(double const &in);
  };
}

#endif

