#include "coupledsinefunction.ih"

double CoupledSineFunction::operator()(double const& in)
{
  double phaseDeriv = 2.0 * M_PI / d_period + d_coupling * sin(in - d_phase + d_phaseOffset);
  d_phase = d_phase + 0.02 * phaseDeriv;
  _debugLevel1("Phase: " << d_phase << " " << d_amplitude << " " << d_offset);
  double angle = d_amplitude * sin(d_phase) + d_offset;
  return angle;
}

