#ifndef _INCLUDED_LEAKYINTEGRATOR_
#define _INCLUDED_LEAKYINTEGRATOR_

template <typename T>
class LeakyIntegrator
{
  T d_value;
  double d_convergence;

 public:
  LeakyIntegrator(double convergence, T start_value) 
    {
      settings(convergence, start_value);
    }

  LeakyIntegrator()
    {}

  void settings(double convergence, T start_value)
    {
      d_value = start_value;
      d_convergence = convergence;
    }

  void update(T update_value)
    {
      d_value = d_value * (1.0 - d_convergence) + update_value * d_convergence;
    }

  T getValue() const
    {
      return d_value;
    }
  
  operator T() const
    {
      return getValue();
    }

  LeakyIntegrator<T> &operator=(T const &other)
    {
      update(other);
      return *this;
    }

 private:
};


#endif
