#ifndef _INCLUDED_MEAN_
#define _INCLUDED_MEAN_

#include "../function/function.hh"
#include <vector>
#include <iostream> ///

template <typename RET, typename IN>
class Mean : public Function<RET, IN>
{
  typedef std::vector< Function<RET, IN> *> FunctionVector;
  FunctionVector d_functions;
  RET d_null_value;

public:
  Mean();
  Mean(RET const &null_value);

  RET operator()(IN const &in);

  void addFunction(Function<RET, IN> *function);
private:
};

template <typename RET, typename IN>
Mean<RET, IN>::Mean()
{
}

template <typename RET, typename IN>
Mean<RET, IN>::Mean(RET const &null_value)
  :
  d_null_value(null_value)
{
}

template <typename RET, typename IN>
void Mean<RET, IN>::addFunction(Function<RET, IN> *function)
{
  d_functions.push_back(function);
}

template <typename RET, typename IN>
RET Mean<RET, IN>::operator()(IN const &in)
{
  typename FunctionVector::iterator it(d_functions.begin());
  typename FunctionVector::iterator end(d_functions.end());

  RET ret(d_null_value);
  

  for (; it != end; ++it)
      ret += (*(*it))(in);

  ret /= d_functions.size();

  return ret;
}
        
#endif
