#ifndef _INCLUDED_NORMDIST_
#define _INCLUDED_NORMDIST_

#include "../function.hh"
#include <cmath>

//norm distr met maximale waarde 1, dus niet een echte norm dist

namespace bats
{
class NormDist : public Function<double, double>
{
    double d_sigma, d_mu, d_factor;

    public:
        NormDist(double mu = 1.0, double sigma = 1.0, double factor = 1.0)
            : d_sigma(sigma), d_mu(mu), d_factor(factor)
        {}

        double operator()(double const &in)
        {
           return d_factor * exp(- ((in - d_mu) * (in - d_mu)) / (2 * d_sigma * d_sigma) );
        }

    private:
};

}        
#endif

