#ifndef _INCLUDED_PATTERNGENERATOR_
#define _INCLUDED_PATTERNGENERATOR_

#include "../function/function.hh"
#include <vector>
#include <iostream>

template <typename RET, typename IN>
class PatternGenerator : public Function<std::vector<RET>, IN>
{
  typedef std::vector< Function<RET, IN> *> FunctionVector;

  FunctionVector d_functions;

public:
  PatternGenerator();

  std::vector<RET> operator()(IN const &in);

  void addFunction(Function<RET, IN> *function);

private:
};

template <typename RET, typename IN>
PatternGenerator<RET, IN>::PatternGenerator()
{
}
 
template <typename RET, typename IN>
std::vector<RET> PatternGenerator<RET, IN>::operator()(IN const &in)
{

  std::vector<RET> ret;
  typename FunctionVector::iterator it(d_functions.begin());
  typename FunctionVector::iterator end(d_functions.end());

  for (;it != end; ++it)
      ret.push_back((*(*it))(in));

  return ret;
}

template <typename RET, typename IN>
void PatternGenerator<RET, IN>::addFunction(Function<RET, IN> *function)
{
  d_functions.push_back(function);
}
       
#endif
