#include "posturecombiner.ih"

void PostureCombiner::initWalkModuleBackward()
{
  Mean<double, double> mean_lleg2;
  mean_lleg2.addFunction(new SineFunction(4, 0.5, 0, 60));
  mean_lleg2.addFunction(new SineFunction(4, 0.5, 1.570796327, 0));

  Mean<double, double> mean_rleg2;
  mean_rleg2.addFunction(new SineFunction(-4, 0.5, 0, 60));
  mean_rleg2.addFunction(new SineFunction(-4, 0.5, 1.570796327, 0));

  Mean<double, double> mean_lleg4;
  mean_lleg4.addFunction(new SineFunction(-8, 0.5, 0, -50));

  Mean<double, double> mean_rleg4;
  mean_rleg4.addFunction(new SineFunction(8, 0.5, 0, -50));
  
  Mean<double, double> mean_lleg5;
  mean_lleg5.addFunction(new SineFunction(4, 0.5, 0, 18));
  mean_lleg5.addFunction(new SineFunction(-4, 0.5, 1.570796327, 0));

  Mean<double, double> mean_rleg5;
  mean_rleg5.addFunction(new SineFunction(-4, 0.5, 0, 18));
  mean_rleg5.addFunction(new SineFunction(4, 0.5, 1.570796327, 0));

  PostureGenerator generator_backward;
  generator_backward.addFunction(Types::LLEG2, new Mean<double, double>(mean_lleg2));  
  generator_backward.addFunction(Types::RLEG2, new Mean<double, double>(mean_rleg2));  
  generator_backward.addFunction(Types::LLEG4, new Mean<double, double>(mean_lleg4));  
  generator_backward.addFunction(Types::RLEG4, new Mean<double, double>(mean_rleg4));  
  generator_backward.addFunction(Types::LLEG5, new Mean<double, double>(mean_lleg5));  
  generator_backward.addFunction(Types::RLEG5, new Mean<double, double>(mean_rleg5));  
  
  PostureCombiner::s_walk_module.addFunction(new PostureGenerator(generator_backward));

}
