#include "posturecombiner.ih"

void PostureCombiner::initWalkModuleTurnRight()
{
  Mean<double, double> mean_lleg2;
  mean_lleg2.addFunction(new SineFunction(4, 0.5, 0, 60));

  Mean<double, double> mean_rleg2;
  mean_rleg2.addFunction(new SineFunction(-4, 0.5, 0, 60));

  Mean<double, double> mean_lleg4;
  mean_lleg4.addFunction(new SineFunction(-8, 0.5, 0, -50));

  Mean<double, double> mean_rleg4;
  mean_rleg4.addFunction(new SineFunction(8, 0.5, 0, -50));
  
  Mean<double, double> mean_lleg5;
  mean_lleg5.addFunction(new SineFunction(4, 0.5, 0, 18));

  Mean<double, double> mean_rleg5;
  mean_rleg5.addFunction(new SineFunction(-4, 0.5, 0, 18));

  Mean<double, double> mean_lleg1;
  mean_lleg1.addFunction(new SineFunction(4, 0.5, 1.570796327, 0));

  Mean<double, double> mean_rleg1;
  mean_rleg1.addFunction(new SineFunction(-4, 0.5, 1.570796327, 0));

  Mean<double, double> mean_lleg3;
  mean_lleg3.addFunction(new SineFunction(-4, 0.5, 1.570796327, 0));

  Mean<double, double> mean_rleg3;
  mean_rleg3.addFunction(new SineFunction(4, 0.5, 1.570796327, 0));

  Mean<double, double> mean_lleg6;
  mean_lleg6.addFunction(new SineFunction(4, 0.5, 1.570796327, 0));

  Mean<double, double> mean_rleg6;
  mean_rleg6.addFunction(new SineFunction(-4, 0.5, 1.570796327, 0));



  PostureGenerator generator_turn_right;
  generator_turn_right.addFunction(Types::LLEG2, new Mean<double, double>(mean_lleg2));  
  generator_turn_right.addFunction(Types::RLEG2, new Mean<double, double>(mean_rleg2));  
  generator_turn_right.addFunction(Types::LLEG4, new Mean<double, double>(mean_lleg4));  
  generator_turn_right.addFunction(Types::RLEG4, new Mean<double, double>(mean_rleg4));  
  generator_turn_right.addFunction(Types::LLEG5, new Mean<double, double>(mean_lleg5));  
  generator_turn_right.addFunction(Types::RLEG5, new Mean<double, double>(mean_rleg5));  
  generator_turn_right.addFunction(Types::LLEG1, new Mean<double, double>(mean_lleg1));  
  generator_turn_right.addFunction(Types::RLEG1, new Mean<double, double>(mean_rleg1));  
  generator_turn_right.addFunction(Types::LLEG3, new Mean<double, double>(mean_lleg3));  
  generator_turn_right.addFunction(Types::RLEG3, new Mean<double, double>(mean_rleg3));  
  generator_turn_right.addFunction(Types::LLEG6, new Mean<double, double>(mean_lleg6));  
  generator_turn_right.addFunction(Types::RLEG6, new Mean<double, double>(mean_rleg6));  
  
  PostureCombiner::s_walk_module.addFunction(new PostureGenerator(generator_turn_right));
}
