#ifndef _INCLUDED_POSTURECOMBINER_
#define _INCLUDED_POSTURECOMBINER_

#include "../function/function.hh"
#include "../posturegenerator/posturegenerator.hh"
#include <vector>

class PostureCombiner : public Function<Posture, double>
{
  typedef Function<Posture, double> PostureFunction;

public:
  static PostureCombiner s_walk_module;
  
private:
  std::vector<PostureFunction *> d_functions;
  std::vector<double> d_weights;
  
  static bool s_walk_module_initialized;

public: 
  virtual Posture operator()(double const &in);
  virtual void addFunction(Function<Posture, double> *function, double weight = 0.0);
  virtual void updateWeights(std::vector<double> const &weights);
  
  static void initWalkModule();
  static void initWalkModuleForward();
  static void initWalkModuleBackward();
  static void initWalkModuleStrafeLeft();
  static void initWalkModuleStrafeRight();
  static void initWalkModuleTurnLeft();
  static void initWalkModuleTurnRight();

private:
};

        
#endif
