#ifndef _INCLUDED_SCALER_
#define _INCLUDED_SCALER_

#include "function/function.hh"
#include "posture/posture.hh"
#include "posturecombiner/posturecombiner.hh"
#include <vector>

class Scaler : public PostureCombiner
{
  PostureCombiner *d_function;
  double d_scaler;

public:

  Scaler(PostureCombiner &function);
  
  Posture operator()(double const &in);
  
  void addFunction(Function<Posture, double> *function, double weight = 0.0);  
  void updateWeights(std::vector<double> const &parameter);
private:

  double scale();
};

        
#endif
