#include "vectorpredictor.ih"

Vector3D VectorPredictor::predict(double time_from_now) const
{
  Vector3D guess(d_vectors[0]);
  
  vector<LeakyIntegrator<Vector3D> >::const_iterator it = d_li_vectors.begin();
  vector<LeakyIntegrator<Vector3D> >::const_iterator end = d_li_vectors.end();

  int i(1);
  for (++it; it != end; ++it, ++i)
    guess += static_cast<Vector3D>(*it) * (1.0 / faculty(i))  * pow(time_from_now, i);

  return guess;
}

