#ifndef _BATS_SINGLETON_HH_
#define _BATS_SINGLETON_HH_

namespace bats
{
  template <class T>
  class Singleton
  {
  public:
    static T& getInstance() {
      static T instance;
      return instance;
    }
  private:
    Singleton();
    ~Singleton();
    Singleton(Singleton const&);
    Singleton& operator=(Singleton const&);
  };
}

#endif
