#ifndef __INC_BATS_TRAINERSOCKETCOMM_HH_
#define __INC_BATS_TRAINERSOCKETCOMM_HH_

#include "socketcomm.hh"
#include "worldmodel.hh"
#include "singleton.hh"

namespace bats
{
  class TrainerSocketComm : public SocketComm
  {
    friend class Singleton<TrainerSocketComm>;

    TrainerSocketComm(TrainerSocketComm const&); //NI
    TrainerSocketComm& operator=(TrainerSocketComm const&); //NI
    
    TrainerSocketComm()
    {}

  public:
    
    void setBallPos(Vector3D const& pos);
    
    static rf<Predicate> makeSetBallPosMessage(Vector3D const& pos);
    
    void setBallVel(Vector3D const& vel);
    
    static rf<Predicate> makeSetBallVelMessage(Vector3D const& vel);
    
    void setBallPosVel(Vector3D const& pos, Vector3D const& vel);
    
    static rf<Predicate> makeSetBallPosVelMessage(Vector3D const& pos, Vector3D const& vel);
    
    void kickOff();
    
    static rf<Predicate> makeKickOffMessage();
    
    void setPlayMode(Types::PlayMode mode);
    
    static rf<Predicate> makeSetPlayModeMessage(Types::PlayMode mode);
  };
  
  typedef Singleton<TrainerSocketComm> STrainerSocketComm;
};

#endif
