#ifndef _INCLUDED_STACKCHECK_
#define _INCLUDED_STACKCHECK_

#include <vector>
#include <string>
#include <fstream>

class StackCheck
{
  static StackCheck *s_instance;

 public:
  static void initialize(std::string const &filename = "stack.history", size_t max_depth = 0);
  static StackCheck &getInstance();

 private:

  typedef std::vector<std::string> Stack;
  
  std::ofstream d_outfile;

  Stack d_current_stack_id;
  Stack d_previous_stack_id;

  Stack d_current_stack_name;
  Stack d_previous_stack_name;

  size_t d_max_depth;
  Stack d_stop_names;
  bool d_full;

    public:
  
  void wasCalled(std::string const &id, std::string const &name);
  void clear();
  
  void printIfChanged();

 private:
  StackCheck(std::string const &filename, size_t max_depth);

  void printStack();
  void createFile(std::string const &filename);
  
};

        
#endif
