#ifndef _INCLUDED_VALUEFIELD_
#define _INCLUDED_VALUEFIELD_

#include <string>
#include <vector>

#include "../valuepointcreator/valuepointcreator.h"
#include "../valuepoint/valuepoint.h"

class ValueField
{
  std::string d_name;
  ValuePointCreator *d_creator;
  
  std::vector<ValuePoint> d_points;
  size_t d_n_points;
  
  ValuePoint d_max_point;
  ValuePoint d_min_point;

  typedef std::vector<ValuePoint> ValuePointVector;
 public:

  ValueField(std::string name, ValuePointCreator *creator, size_t n_points)
    :
    d_name(name),
    d_creator(creator),
    d_n_points(n_points)
    {}
  
  ~ValueField()
    {
      if (d_creator)
	delete d_creator;
    }

  void update(WorldModel &wm, AgentModel &am, double width, double height);

  void clear()
    {
      d_points.clear();
      d_min_point = ValuePoint(0, 0, 99999);
      d_max_point = ValuePoint(0, 0, -99999);
    }

  ValuePoint getMaxPoint()
    {
      return d_max_point;
    }

  ValuePoint getMinPoint()
    {
      return d_min_point;
    }

  ValuePoint getValue(double x, double y);
  
 private:
};

        
#endif
