#ifndef _INCLUDED_VALUEPOINT_
#define _INCLUDED_VALUEPOINT_

#include "vector3.hh"

class ValuePoint
{
 public:
  bats::Vector3D d_point; //geen 3d vector, maar 2d met een normalisatie waarde
  double d_value;
  
 public:
  ValuePoint(double x = 0, double y = 0, double value = 0)
    :
    d_point(x, y, 1),
    d_value(value)
    {}
  
  double getX()
    {
      return d_point.getX();
    }

  double getY()
    {
      return d_point.getY();
    }

  double getValue()
    {
      return d_value;
    }
  
  ValuePoint &operator*(double value)
    {
      d_point *= value;
      d_value *= value;
      return *this;
    }

  ValuePoint &operator+(ValuePoint &other)
    {
      d_point += other.d_point;
      d_value += other.d_value;
      return *this;
    }

  void normalize()
    {
      d_point /= d_point.getZ();
      d_value /= d_point.getZ();
    }

  bool operator<(ValuePoint const &other) const
    {
      return this->d_value < other.d_value;
    }

  bool operator>(ValuePoint const &other) const
    {
      return this->d_value > other.d_value;
    }

 private:
};

        
#endif
