#include "talent.ih"

double Talent::calcJointGradient(Vector3D curPos, Vector3D target, Types::Joint joint)
{
  AgentModel& am = SAgentModel::getInstance();
  
  //Matrix4D partTransform = wm.getBodyPart(bodyPart).transform;
  //_debugLevel4("Transform: " << footTransform.trans());
  
  Matrix4D jointTransform = am.getJoint(joint)->transform;
  
  Vector3D axis = am.getJoint(joint)->getAxisVec();
  _debugLevel1("Axis: " << axis);
  
  Vector3D jointToPart = curPos - jointTransform.trans();
  _debugLevel1("joint to body part: " << jointToPart);
  
  Vector3D partToTarget = target - curPos;
  _debugLevel1("partToTarget: " << partToTarget);
  
  Vector3D movement = jointToPart.crossProduct(axis);
  _debugLevel1("movement: " << movement);
  
  double gradient = -(movement * partToTarget);
  _debugLevel1("gradient: " << gradient);
  return gradient;
}

