#!/bin/sh

if [ "x$1" = "xclean" ]; then
	echo Cleaning
	echo DONDOODODNODNODNODNODNO
	make distclean
  rm -f confi
  rm -rf autom4te.cache config.aux m4
	exit
fi

## Generate Makefile.am from MD5SUMS
PSOURCE=humanoidbat.cc
PNAME=`basename "${PSOURCE}" .cc`
echo "Generating Makefile.am from MD5SUMS"
#Update MD5SUMS
which ccbuild && (ccbuild md5 --recursive-include . "${PSOURCE}" > MD5SUMS)
which ccbuild && (ccbuild makefile --nodefargs --recursive-include . > Makefile.human)

SOURCES=`sed  -r 's/^[a-z0-9]+  //; s/ /\\ /' < MD5SUMS | tr '\n' ' '`

#Overwrite Makefile.am
cat > Makefile.am <<EOF
#THIS FILE IS AUTOMATICALLY GENERATED AUTOMATICALLY BY bootstrap.sh
# DO NOT EDIT THIS, BUT EDIT THAT
PACKAGE = @PACKAGE@
VERSION = @VERSION@

AUTOMAKE_OPTIONS = subdir-objects

bin_PROGRAMS = ${PNAME}

#List of source files needed to build the executable:
${PNAME}_SOURCES = ${SOURCES}

INCLUDES = \$(DEPS_CFLAGS) -I. -I./AST -I./AgentModel -I./BatsException -I./Behavior -I./Behavior/BeamTo -I./Behavior/CatchFallBack -I./Behavior/CatchFallFront -I./Behavior/CatchFallSide -I./Behavior/Challenge1 -I./Behavior/Console -I./Behavior/CornerKick -I./Behavior/CoupledWalk -I./Behavior/CubicSpline -I./Behavior/CubicSpline/interpolation -I./Behavior/CubicSpline/interpolation/libs -I./Behavior/Defend -I./Behavior/Empty -I./Behavior/FallOver -I./Behavior/GAWalk -I./Behavior/GetFromSide -I./Behavior/GetUpFromBack -I./Behavior/GetUpFromBelly -I./Behavior/GetUpQuick -I./Behavior/GetUpSlow -I./Behavior/GetUpSlowFromBack -I./Behavior/GetUpSlowFromBelly -I./Behavior/GoalKick -I./Behavior/GoodPosition -I./Behavior/GoodPositionAngle -I./Behavior/GuardGoal -I./Behavior/JointInterface -I./Behavior/KeeperGetUp -I./Behavior/KickBall -I./Behavior/KickOff -I./Behavior/KickTo -I./Behavior/MiniWalkBackward -I./Behavior/MiniWalkCombined -I./Behavior/MiniWalkForward -I./Behavior/MoveJointTo -I./Behavior/OtherOnGround -I./Behavior/PeriodicInterface -I./Behavior/PeriodicJoint -I./Behavior/PositionFoot -I./Behavior/PrimitiveBehavior -I./Behavior/PrimitiveBehavior/Beam -I./Behavior/PrimitiveBehavior/MoveHingeJoint -I./Behavior/PrimitiveBehavior/MoveJoint -I./Behavior/PrimitiveBehavior/MoveUniversalJoint -I./Behavior/PushUpFromBack -I./Behavior/PushUpFromBelly -I./Behavior/QuitRun -I./Behavior/RemoteControl -I./Behavior/Reset -I./Behavior/Score -I./Behavior/ScorpiusBlocker -I./Behavior/ScriptPlayer -I./Behavior/Sine -I./Behavior/Stabilize -I./Behavior/StrafeLeft -I./Behavior/StrafeRight -I./Behavior/StrafeToBall -I./Behavior/Trainer -I./Behavior/Trainer/KickTrainer -I./Behavior/Transition -I./Behavior/TrippleCombined -I./Behavior/TurnTo -I./Behavior/Wait -I./Behavior/WaitForOpponent -I./Behavior/WalkStraightTo -I./Behavior/WalkTo -I./Behavior/WalkToAvoid -I./Behavior/ZeroGoodPositionAngle -I./Behavior/canKickLeft -I./Behavior/canKickRight -I./Behavior/canTurnLeft -I./Behavior/canTurnRight -I./Cerebellum -I./Cochlea -I./Conf -I./Distribution1 -I./Distribution1/NormalDistribution1 -I./Distribution3D -I./Distribution3D/MonteCarloDistribution -I./Distribution3D/NormalDistribution3D -I./FitnessFunction -I./FitnessFunction/FitnessTurn -I./FitnessFunction/FitnessWalk -I./Functions -I./Functions/avoider -I./Functions/bufferedif -I./Functions/function -I./Functions/function/CoupledSineFunction -I./Functions/leakyintegrator -I./Functions/mean -I./Functions/patterngenerator -I./Functions/posture -I./Functions/posturecombiner -I./Functions/posturegenerator -I./Functions/scaler -I./Functions/sinefunction -I./Functions/vectorpredictor -I./Hashclasses -I./HumanoidAgent -I./HumanoidAgent/HumanoidBat -I./Input -I./Logger -I./Math -I./Matrix4D -I./Matrix9 -I./Net -I./Parser -I./Path -I./PortableParser -I./Predicate -I./Preprocessor -I./Ref -I./RefAble -I./Singleton -I./SocketComm -I./SocketComm/AgentSocketComm -I./SocketComm/TrainerSocketComm -I./StackCheck -I./Tactiek -I./Tactiek/valuefield -I./Tactiek/valuepoint -I./Tactiek/valuepointcreator -I./Talent -I./Types -I./Vector3 -I./Vector4 -I./WorldModel -I./autom4te.cache -I./confinc -I./docs -I./docs/TDP -I./docs/TDP08 -I./docs/TDP2008 -I./docs/TDPIran08 -I./docs/agent_paper -I./docs/exc -I./docs/howtorobocop -I./global -I./naoconfinc -I./util

${PNAME}_LDADD = \$(DEPS_LIBS)
EOF

rm -f config.cache acconfig.h

echo "- aclocal."		&& \
aclocal	&& \
echo "- autoconf."		&& \
autoconf			&& \
echo "- automake."		&& \
automake --add-missing --copy

