#ifndef _INCLUDED_SHOOTFIELD_
#define _INCLUDED_SHOOTFIELD_

#include <vector>
#include "function.hh"

namespace bats
{

enum Check
{
    OPPONENTS = 1, 
    PLAYERS = 2,
    BALL = 4,
    GOAL = 8,
    FORWARD = 16,
    ALL = 31
};

class ShootField
{
    size_t d_res;
    std::vector<double> d_values;


    double d_highest_angle;
    double d_highest_value;

 public:
    ShootField(size_t res);

    void calculate(Check check = ALL);
    double bestAngle();
        

   double getHighestAngle() const {return d_highest_angle; }
   double getHighestValue() const {return d_highest_value; }

    private:
        void clear();
};

}        
#endif
