#ifndef _INCLUDED_ATTACKDEFEND_
#define _INCLUDED_ATTACKDEFEND_

#include "vector3.hh"
#include "tacticset.h"

namespace bats
{
class AttackDefend : public TacticSet
{
    BufferedIf d_buffered_if_other_on_ground;

    public:
        AttackDefend();

      virtual bool isApplicable();
      virtual Vector3D firstPlayerPos();
      virtual Vector3D secondPlayerPos();

      virtual double firstPlayerAngle();
      virtual double secondPlayerAngle();

      virtual bool firstPlayerScore() 
            {
                if (player1ClosestToBall())
                    return true;
                else
                    return false;
            }

      virtual bool secondPlayerScore()
            {
                if (player2ClosestToBall())
                    return true;
                else
                    return false;
            }


    private:

      Vector3D attackPos();
      Vector3D defendPos();

      bool attacking() {return true; }
      bool otherOnGround();
};

}        
#endif
