#include "tacticset.ih"

double TacticSet::danger()
{
    WorldModel &wm = SWorldModel::getInstance();
    AgentModel &am = SAgentModel::getInstance();

    size_t n_players = wm.getNumberOfPlayers();
    size_t n_opponents = 3;//wm.getNumberOfOpponents();

    Vector3D goal = wm.getObject(Types::GOAL1US).position.getMu();
    Vector3D ball = wm.getObject(Types::BALL).position.getMu();
    
    double dist_ball_goal = (goal - ball).length();

    double closest_enemy = 999999;
    Vector3D enemy = Vector3D(0, 0, 0);

      {
        WorldModel::player_iterator it_op = wm.beginOpponents();
        WorldModel::player_iterator end_op = wm.endOpponents();

        for (; it_op != end_op; ++it_op)
        {
          Vector3D other = it_op->second.getPosition();
	  //cout << "o: " << other << " ";
          if (closest_enemy > (other - ball).length() )
            {
                closest_enemy = (other - ball).length();
                enemy = other;
            }
        }
      }

    double pos_enemy = (-(ball - goal).normalize().dotProduct((enemy - ball).normalize()) - 1.0) / 2.0;

    double inverse_danger = dist_ball_goal / 10.0 + pos_enemy * 3.0 + closest_enemy / 4.0;

    //cout << "\r:" << inverse_danger << " d: " << dist_ball_goal << " p: " << pos_enemy * 3.0 << " c: " << closest_enemy << " " << ball.length();
    return 1.0 / (1.0 + inverse_danger);
}
