#ifndef _INCLUDED_TACTICSET_
#define _INCLUDED_TACTICSET_

#include "Vector3/vector3.hh"
#include "shootfield.h"
#include "bufferedif.h"

namespace bats
{

class TacticSet
{
  protected:
   ShootField d_shoot_field;
    BufferedIf d_buffered_if;

 public:
  TacticSet();

  bool player1ClosestToBall() {return closestToBall(1); }
  bool player2ClosestToBall() {return closestToBall(2); }

  bool closestToBall(size_t player_nr);
  bool closestTo(Vector3D pos, size_t player_nr);

  double danger();
  double ballBlocked();


  virtual bool isApplicable();
  virtual Vector3D firstPlayerPos();
  virtual Vector3D secondPlayerPos();

  virtual double firstPlayerAngle();
  virtual double secondPlayerAngle();

  virtual bool firstPlayerScore() {return false; }
  virtual bool secondPlayerScore() {return false; }

  virtual ~TacticSet(){}

 private:
};

}
#endif

