#!/usr/bin/perl

use strict;

sub endPoints {
  <>;

  while (1) {
    my @footpos;
    my $period;
    my @amps = (1..6);
    
    my $line;
    $line = <>;

    while ($line =~ /Param/) {
      @footpos = ($1, $2, $3) if ($line =~ /Footpos: \((.+?),(.+?),(.+?)\)/);

      $period = $1 if ($line =~ /Period: (.*)/);
      
      $amps[$1] = $2 if ($line =~ /Kick Amp (.*?) (.*)/);
      $line = <>;
    }
    
    my @ballStartPos = (0,0,0);
    
    my @ballEndPos = (0,0,0);

    my @ball;

    my $maxDistSqr = -1;
    my $maxDistLine;
    
    while ($line !~ /----------/) {
      $line = <> or exit;
      
      if ($line =~ /ball: \((.+?),(.+?),(.+?),.+?\)/) {
        if ($maxDistSqr == -1) {
          @ballStartPos = ($1, $2, $3);
        } else {
          @ball = ($1, $2, $3);
        }
      } elsif ($line =~ /flag: \((.+?),(.+?),(.+?),.+?\)/) {
        if ($maxDistSqr == -1) {
          $ballEndPos[0] = ($ballStartPos[0] -= $1);
          $ballEndPos[1] = ($ballStartPos[1] -= $2);
          $ballEndPos[2] = ($ballStartPos[2] -= $3);
          $maxDistSqr = 0;
          #print "$ballStartPosX $ballStartPosY $ballStartPosZ\n";
        } else {
          $ball[0] -= $1;
          $ball[1] -= $2;
          $ball[2] -= $3;
          
         
          my $distSqr = ($ballStartPos[0] - $ball[0]) ** 2 + ($ballStartPos[1] - $ball[1]) ** 2 + ($ballStartPos[2] - $ball[2]) ** 2;
          if ($distSqr > $maxDistSqr) {
            @ballEndPos  = @ball;
            $maxDistSqr = $distSqr;
            $maxDistLine = $line;
          }
        }
      }
    }
    #print $maxDistLine;
    #print "\n";
    my @ballDiff = ($ballEndPos[0] - $ballStartPos[0], $ballEndPos[1] - $ballStartPos[1], $ballEndPos[2] - $ballStartPos[2]);
    print "$period " . join(" ", @footpos) . " " . join(" ", @ballDiff) . "\n";
    #exit;
  }
}

sub runSettings {
  my $line = <STDIN>;
  
  my $run = pop;
  
  my $curRun = 1;
  
  while ($curRun != $run) {
    while (<STDIN> !~ /----------/) {}
    ++$curRun;
  }
  
  for (my $i = 0; $i < 4; ++$i) {
    $line = <STDIN>;
    print $line;
  }
}

if ($#ARGV == 1 && $ARGV[0] eq "-r") {
  runSettings($ARGV[1]);
} else {
  endPoints;
}

